
			ORG	08000h
2769   8000 31 00 80	L8000:	LD	SP,08000h		;nastav zasobnik
2770   8003 C3 06 80		JP	L0001			;prepnuti EPROM na adresu 08000h
2771   8006 3E 8A	L0001:	LD	A,08Ah			;PA OUT, PB IN, PCL OUT, PCH IN
2772   8008 D3 F7		OUT	(0F7h),A		;CW PIO 8255
2773   800A CD 1C 8B		CALL	L0002			;OCHRAN - ochrana proti prohlizeni pameti
2774   800D 21 30 C0	L0201:	LD	HL,0C030h		;zapisnikova oblast vedle VRAM
2775   8010 0E 30		LD	C,030h			;offset dalsi oblasti vedle VRAM
2776   8012 3E 08		LD	A,008h			;kopiruje se 8 bloku po 010h byte
2777   8014 F5		L0004:	PUSH	AF
2778   8015 06 10		LD	B,010h			;kopiruje se 010h byte
2779   8017 1A		L0003:	LD	A,(DE)			;naplneni oblasti 0C030,0C070,0C0B0,...
2780   8018 77			LD	(HL),A
2781   8019 23			INC	HL			;dalsi cilova adresa
2782   801A 13			INC	DE			;dalsi zdrojova adresa
2783   801B 05			DEC	B			;pocet byte v 1 bloku
2784   801C C2 17 80		JP	NZ,L0003		;presun 010h byte
2785   801F 09			ADD	HL,BC			;dalsi cilova adresa
2786   8020 F1			POP	AF			;pocitadlo oblasti
2787   8021 3D			DEC	A			;sniz pocet zbyvajicich oblasti
2788   8022 C2 14 80		JP	NZ,L0004		;opakuj pro vsechny oblasti
2789   8025 2A 7C C1		LD	HL,(0C17Ch)		;adresa klicu
2790   8028 2B			DEC	HL
2791   8029 77			LD	(HL),A
2792   802A CD 6B 8C		CALL	L0005			;nastaveni 8255 + smazani obrazovky
2793   802D 21 89 81		LD	HL,08189h		;data pro uvitaci melodii
2794   8030 CD A6 88		CALL	L88A6			;zahraj uvitaci melodii
2795   8033 3A B2 C1		LD	A,(0C1B2h)		;tabulka hlavicky souboru
2796   8036 FE CD		CP	0CDh			;test na CD (CALL ?)
2797   8038 CA B2 C1		JP	Z,L0007			;zde se meni adresa dalsiho skoku

			;******************************************************************************
			;Obsluha klavesy MON
			;MON - vstup do MONITORu z uzivatelskeho programu
			; vyst.: vstoupi do MONITORu a poda zpravu ** OS READY **
			;******************************************************************************
2798   803B 21 6D 83	L803B:	LD	HL,0836Dh		;text '** OS READY **'
2799   803E 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
2800   8041 3E 3F		LD	A,03Fh
2801   8043 32 36 C1		LD	(0C136h),A		;typ souboru pro MGSV, MGLD, MGEND
2802   8046 CD 13 81	L0016:	CALL	L0008			;obsluha klavesy CLL - vymaz celeho radku
2803   8049 CD 31 8B	L0032:	CALL	L0009			;ERROR - vypis chyboveho hlaseni - zde OS READY
2804   804C CD A1 84		CALL	L0010			;INKLAV - nacteni znaku z klavesnice s cekanim na stisk
2805   804F FE 0D		CP	00Dh			;stisknuto EOL?
2806   8051 C4 43 8C		CALL	NZ,L0011		;ne, skoc - DOKEY - provedeni zmeny v editacnim bufferu

			;******************************************************************************
			;MAIN - vstup do hlavni smycky MONITORu
			;******************************************************************************
2807   8054 CD 55 88	L0052:	CALL	L0012			;WRLINE - vypis editacniho bufferu do dialogoveho radku
2808   8057 2A 70 C0		LD	HL,(0C070h)		;adresa vrcholu zasobniku
2809   805A F9			LD	SP,HL
2810   805B CD EE 8B		CALL	L0013			;ENTER - vstup radky s editaci
2811   805E 21 92 83		LD	HL,08392h		;text '++ NO COMMAND ++'
2812   8061 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
2813   8064 21 54 80		LD	HL,08054h		;pocatek smycky MAIN
2814   8067 E5			PUSH	HL			;uloz do zasobniku
2815   8068 2A 7E C0		LD	HL,(0C07Eh)		;zacatek tabulky prikazu MONITORu
2816   806B EB			EX	DE,HL			;v DE je pocatek tabulky prikazu
2817   806C 2A 78 C0	L0018:	LD	HL,(0C078h)		;adresa ulozeni textu po EOL v ENTER
2818   806F 13		L0015:	INC	DE			;dalsi pozice v tabulce
2819   8070 1A			LD	A,(DE)			;cti znak z tabulky
2820   8071 A7			AND	A			;test na konec prikazu MONITORu
2821   8072 CA 79 85		JP	Z,L0014			;je-li 000h, prikaz nalezen - skoc na SYST1
2822   8075 BE			CP	(HL)			;porovnej s editacnim buferem
2823   8076 23			INC	HL			;dalsi pozice v buferu
2824   8077 CA 6F 80		JP	Z,L0015			;znaky se shoduji, porovnej dalsi
2825   807A 3C			INC	A			;test na konec dekodovaci tabulky - zarazka je 0FFh
2826   807B CA 46 80		JP	Z,L0016			;obsluha CLL, zprava NO COMMAND, opakovani smycky monitoru
2827   807E 1A		L0017:	LD	A,(DE)			;cti znak z tabulky
2828   807F A7			AND	A			;najdi zarazku konce prikazu MONITORu
2829   8080 13			INC	DE			;dalsi znak v tabulce
2830   8081 C2 7E 80		JP	NZ,L0017		;vyhledani zacatku dalsiho prikazu
2831   8084 13			INC	DE			;dopreskoceni adresy obsluhy prikazu
2832   8085 C3 6C 80		JP	L0018			;porovnavej dalsi prikaz MONITORu z tabulky

			;******************************************************************************
			;ROLL - posun obrazu smerem vzhuru o 1 radek
			; vstup: IIROLL 0C0F4h
			; nelze pouzit s povolenym prerusenim !!!
			;******************************************************************************
2833   8088 21 00 00	L0108:	LD	HL,00000h		;priprava na zalohu SP
2834   808B 39			ADD	HL,SP			;cti SP
2835   808C 22 3E C1		LD	(0C13Eh),HL		;misto pro odkladani ukazatele zasobniku
2836   808F 2A FC C0		LD	HL,(0C0FCh)		;roztec radku - delka mikroradku - 040h
2837   8092 01 00 C0		LD	BC,0C000h		;pocatek VRAM
2838   8095 09			ADD	HL,BC			;0C000h+00040h=0C040h
2839   8096 F9			LD	SP,HL			;vysledek dej do SP
2840   8097 21 FF BF		LD	HL,0BFFFh		;pocatek VRAM-1 - hned bude INC HL
2841   809A 3A F4 C0		LD	A,(0C0F4h)		;pocet posouvanych linek displeje - 0EAh
2842   809D 06 08	L0020:	LD	B,008h			;prenos 8*6 byte = 48 bytes = 1 mikroradek
2843   809F D1		L0019:	POP	DE			;precti data z VRAM	DE=(0C040h), SP=SP+2
2844   80A0 23			INC	HL			;misto pro ulozeni dat	HL=0C000h
2845   80A1 73			LD	(HL),E			;uloz LOW byte
2846   80A2 23			INC	HL			;dalsi cilova adresa ve VRAM
2847   80A3 72			LD	(HL),D			;uloz HIGH byte
2848   80A4 D1			POP	DE			;precti data z VRAM	DE=(0C042h), SP=SP+2
2849   80A5 23			INC	HL			;dalsi cilova adresa ve VRAM
2850   80A6 73			LD	(HL),E			;uloz LOW byte
2851   80A7 23			INC	HL    			;dalsi cilova adresa ve VRAM
2852   80A8 72			LD	(HL),D			;uloz HIGH byte
2853   80A9 D1			POP	DE    			;precti data z VRAM	DE=(0C044h), SP=SP+2
2854   80AA 23			INC	HL    			;dalsi cilova adresa ve VRAM
2855   80AB 73			LD	(HL),E			;uloz LOW byte
2856   80AC 23			INC	HL    			;dalsi cilova adresa ve VRAM
2857   80AD 72			LD	(HL),D			;uloz HIGH byte
2858   80AE 05			DEC	B			;pocitadlo puchodu
2859   80AF C2 9F 80		JP	NZ,L0019		;opakuj 8x
2860   80B2 EB			EX	DE,HL			;schovej si HL
2861   80B3 21 10 00		LD	HL,00010h		;preskoceni zapisnikove casti vedle VRAM
2862   80B6 39			ADD	HL,SP			;spocti novou zdrojovou adresu VRAM
2863   80B7 F9			LD	SP,HL			;vloz zdrojovou adresu do SP
2864   80B8 21 10 00		LD	HL,00010h		;preskoceni zapisnikove casti vedle VRAM
2865   80BB 19			ADD	HL,DE			;spocti novou cilovou adresu ve VRAM
2866   80BC 3D			DEC	A			;sniz pocitadlo mikroradku
2867   80BD C2 9D 80		JP	NZ,L0020		;opakuj pro vsechny mikroradky
2868   80C0 2A 3E C1		LD	HL,(0C13Eh)		;misto pro odkladani ukazatele zasobniku
2869   80C3 F9			LD	SP,HL			;obnov si SP
2870   80C4 2A F6 C0		LD	HL,(0C0F6h)		;posledni radek
2871   80C7 EB			EX	DE,HL			;v DE je posledni mazany radek
2872   80C8 3A F5 C0		LD	A,(0C0F5h)		;pocet mazanych linek = 009h
2873   80CB 47			LD	B,A			;v B je pocet mazanych linek
2874   80CC 2A F8 C0		LD	HL,(0C0F8h)		;adresa psani dalsi radky = 0FD00h
2875   80CF C3 B3 85		JP	L0021			;SWIND - vymazani casti obrazovky - okno

2876   80D2 0A		V80D2:	DB	00Ah,014h,00Ah,01Eh,0FFh	;data definice standardniho pipnuti + zarazka

			V80D7:	DB	001h,002h,004h,008h,010h,020h,040h,080h	;bitova maska bodu na displeji 

2885   80DF 7E		L0024:	LD	A,(HL)			;prevadi se znak z (HL) do Acc 0..F

			;******************************************************************************
			;HEX - vstupni hex konverze 4 bity
			; vstup: A=ASCII prevadeneho znaku
			; vyst.: prevede ASCII do hex
			; CY=1 neni to hex cislice /chyba/
			; NC= je to hex cislice, A= 0..15
			;******************************************************************************
2886   80E0 FE 30	L0337:	CP	030h			;je znak vetsi nez 030h?
2887   80E2 D8			RET	C			;neni, navrat
2888   80E3 FE 3A		CP	03Ah			;je znak mensi nez 03Ah?
2889   80E5 DA F1 80		JP	C,L0023			;ano, je to jen cislice, skoc
2890   80E8 D6 07		SUB	007h			;neni cislo, posun k cislum
2891   80EA FE 3A		CP	03Ah			;po uprave je mensi nez 03Ah?
2892   80EC D8			RET	C			;ano, navrat
2893   80ED FE 40		CP	040h			;je vetsi nez 040h?
2894   80EF 3F			CCF				;invertuj CARRY
2895   80F0 D8			RET	C			;ano, navrat
2896   80F1 E6 0F	L0023:	AND	00Fh			;odmaskuj jen nejnizsi bity
2897   80F3 C9			RET				;navrat

2898   80F4 03		V80F4:	DB	003h,019h,0FFh		;data definice tonu stisknute klavesy + zarazka

			;******************************************************************************
			;PAIRIN - vstupni hex konverze 8 bitu
			; vstup: HL= adr. textu - dve hex cislice
			; vyst.: CY= chyba
			; NC= spravne prevedeno, A=0..255
			; znici: HL, B, PSW
			;******************************************************************************
2901   80F7 CD DF 80	L0025:	CALL	L0024			;prevod 4 bitu v(HL) na 0..F
2902   80FA D8			RET	C			;chyba, navrat
2903   80FB 07			RLCA				;posun vysledek do hornich nibble
2904   80FC 07			RLCA
2905   80FD 07		L0022:	RLCA
2906   80FE 07			RLCA
2907   80FF 47			LD	B,A			;schovej si vysledek
2908   8100 23			INC	HL			;dalsi pozice v buferu
2909   8101 CD DF 80		CALL	L0024			;prevod 4 bitu v(HL) na 0..F
2910   8104 D8			RET	C			;chyba, navrat
2911   8105 23			INC	HL			;dalsi pozice v buferu
2912   8106 B0			OR	B			;sluc s predchozim vysledkem
2913   8107 C9			RET				;navrat

2914   8108 FF		V8108:	DB	0FFh


			;******************************************************************************
			;ADRIN - vstupni hex konverze 16 bitu
			; vstup: HL= adr. textu - 4 hex cislice
			; vyst.: CY= chyba
			; NC= spravne prevedeno, DE= 0..65535
			; znici: HL, DE, B, PSW
			;******************************************************************************
2915   8109 CD F7 80	L0031:	CALL	L0025			;PARIN - konverze hex na 8 bitu
2916   810C D8			RET	C			;chyba, navrat
2917   810D 57			LD	D,A			;umisti vysledek
2918   810E CD F7 80		CALL	L0025			;PARIN - konverze hex na 8 bitu
2919   8111 5F			LD	E,A			;umisti vysledek
2920   8112 C9			RET				;navrat

			;******************************************************************************
			;Obsluha klavesy CLL - vymaz celeho radku
			;******************************************************************************
2921   8113 CD F6 85	L0008:	CALL	L0026			;obsluha klavesy BNGL - posun na zacatek radku

			;******************************************************************************
			;Obsluha klavesy DELL
			;******************************************************************************
2922   8116 CD 5E 81	L8116:	CALL	L0027			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
2923   8119 3A 34 C0		LD	A,(0C034h)		;konec bufferu dialogoveho radku
2924   811C 3C			INC	A
2925   811D 36 20	L0028:	LD	(HL),020h
2926   811F 2C			INC	L
2927   8120 BD			CP	L
2928   8121 C2 1D 81		JP	NZ,L0028
2929   8124 C9			RET

			;******************************************************************************
			;PREVOD1 - vystupni hex konverze 8 bitu s vypisem
			; vstup: A= 0..255
			; vyst.: vola PRTOUT - vysledek vypisuje na obrazovku
			; znici: B, PSW
			;******************************************************************************
2930   8125 47		L0042:	LD	B,A			;schovej si vstupni znak
2931   8126 0F			RRCA				;prohod nibble znaku
2932   8127 0F			RRCA
2933   8128 0F			RRCA
2934   8129 0F			RRCA
2935   812A CD 6B 88		CALL	L0029			;PREVOD0 - vystupni hex konverze 4 bity
2936   812D CD 00 85		CALL	L0030			;PRTOUT - vypis znaku do obrazovky
2937   8130 78			LD	A,B			;obnov si prevadeny znak
2938   8131 CD 6B 88		CALL	L0029			;PREVOD0 - vystupni hex konverze 4 bity
2939   8134 C3 00 85		JP	L0030			;PRTOUT - vypis znaku do obrazovky

			;******************************************************************************
			;Fragment prikazu MONITORu SUB, po vypsani zbytku adresy z DE navrat do
			;smycky monitoru a cekani na doplneni dalsich dat k ulozeni do RAM
			;******************************************************************************
2940   8137 32 36 C0	L0084:	LD	(0C036h),A		;pozice kurzoru v bufferu
2941   813A 7B		L0769:	LD	A,E			;LOW byte adresy pro ukladani dat

			;******************************************************************************
			;PREVOD2 - vystupny hex konverze 8 bitu
			; vstup: A= 0..255
			; HL= adresa bufferu pro vystup - 2 znaky
			; vyst.: konverze A na adrese HL
			; znici: HL, B, PSW
			;******************************************************************************
2942   813B 47		L0083:	LD	B,A			;schovej si vstupni znak
2943   813C 0F			RRCA				;prohod nibble znaku
2944   813D 0F			RRCA
2945   813E 0F			RRCA
2946   813F 0F			RRCA
2947   8140 CD 6B 88		CALL	L0029			;PREVOD0 - vystupni hex konverze 4 bity
2948   8143 77			LD	(HL),A			;uloz vysledek prevodu
2949   8144 23			INC	HL			;dalsi pozice v pameti
2950   8145 78			LD	A,B			;obnov si prevadeny znak
2951   8146 CD 6B 88		CALL	L0029			;PREVOD0 - vystupni hex konverze 4 bity
2952   8149 77			LD	(HL),A			;uloz vysledek prevodu
2953   814A C9			RET

			;******************************************************************************
			;RADR - vstupni hex konverze 16 bitu s vypisem chyby
			; vstup: CURCH C072= adresa textu
			; vyst.: NC= spravne prevedeno, DE= 0..65535
			; CY= vypise ++ ERROR IN ADDRES ++, skoci do MAIN
			;******************************************************************************
2954   814B 2A 72 C0	L0040:	LD	HL,(0C072h)		;nastaveni pri analyze bufferu
2955   814E CD 09 81		CALL	L0031			;ADRIN - konverze hex na 16 bitu
2956   8151 22 72 C0		LD	(0C072h),HL		;nastaveni pri analyze bufferu
2957   8154 D0			RET	NC
2958   8155 21 46 83		LD	HL,V8346		;text '++ ERROR IN ADDRES ++'
2959   8158 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
2960   815B C3 49 80		JP	L0032			;navrat do MONITORu, vypis chyboveho hlaseni

			;******************************************************************************
			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
			; vyst.: HL= adresa akt. znaku
			;******************************************************************************
2961   815E 2A 38 C0	L0027:	LD	HL,(0C038h)		;1. vypisovany znak z bufferu na obrazovku
2962   8161 EB		L0205:	EX	DE,HL
2963   8162 2A 36 C0		LD	HL,(0C036h)		;pozice kurzoru v bufferu
2964   8165 19			ADD	HL,DE
2965   8166 C9			RET

			;******************************************************************************
			;Obsluha klavesy BEEP
			;******************************************************************************
2966   8167 3A BF C0	L8167:	LD	A,(0C0BFh)		;priznak pipnuti pri stisku klavesy
2967   816A EE 01		XOR	001h			;invertuj priznak puknuti
2968   816C 32 BF C0		LD	(0C0BFh),A		;priznak pipnuti pri stisku klavesy
2969   816F C9			RET

			;******************************************************************************
			;Vlastni generovani tonu. V B je delka trvani v D pozadovany vyska tonu
			;******************************************************************************
2970   8170 C5		L0158:	PUSH	BC			;uloz si delku tonu
2971   8171 5A		L0035:	LD	E,D			;do E vyska tonu
2972   8172 DB F6		IN	A,(0F6h)		;cti stav na portu s bzucaku
2973   8174 EE 06		XOR	006h			;neguj bity bzucaku
2974   8176 D3 F6		OUT	(0F6h),A		;zapis zpatky na port
2975   8178 0B		L0034:	DEC	BC			;sniz delku tonu
2976   8179 78			LD	A,B			;test na nulovost BC
2977   817A B1			OR	C
2978   817B CA 85 81		JP	Z,L0033			;je-li 0, konec
2979   817E 1D			DEC	E			;mezera mezi zmenami stavu na bzucaku
2980   817F C2 78 81		JP	NZ,L0034		;jeste neni cas, skoc
2981   8182 C3 71 81		JP	L0035			;vytvoreni dalsiho pulsu na bzucaku
2982   8185 C1		L0033:	POP	BC			;obnov si BC
2983   8186 D3 F6		OUT	(0F6h),A		;shod vystup na bzucaku
2984   8188 C9			RET				;navrat

			;******************************************************************************
			;Tabulka delek a vysek tonu uvitaci melodie. Konec oznacen 0FFh
			;******************************************************************************
2985   8189 0F		V8189:	DB	00Fh,023h,00Fh,020h,00Fh,01Dh,00Fh,01Ah,00Fh,017h
2994   8193 FF			DB	0FFh			;zarazka konce dat pro uvitaci melodii


2995   8194 CD 5E 81	L0223:	CALL	L0027			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
2996   8197 77			LD	(HL),A
2997   8198 3A 3B C0		LD	A,(0C03Bh)		;pozice v bufferu pro pipnuti pred koncem radku
2998   819B BD			CP	L
2999   819C CC A3 88		CALL	Z,L0037

			;******************************************************************************
			;obsluha klavesy SHIFT + --> (INSERT)
			;******************************************************************************
3000   819F 21 36 C0		LD	HL,0C036h		;pozice kurzoru v bufferu
3001   81A2 34			INC	(HL)
3002   81A3 3A FE C0		LD	A,(0C0FEh)		;pocet znaku pro vypis edit bufferu
3003   81A6 BE			CP	(HL)
3004   81A7 C0			RET	NZ
3005   81A8 35			DEC	(HL)

			;******************************************************************************
			;obsluha klavesy CONT + <--
			;******************************************************************************
3006   81A9 21 38 C0		LD	HL,0C038h		;1. vypisovany znak z bufferu na obrazovku
3007   81AC 3A FF C0		LD	A,(0C0FFh)		;DLZP
3008   81AF BE			CP	(HL)
3009   81B0 C8			RET	Z
3010   81B1 34			INC	(HL)
3011   81B2 C9		L0054:	RET

			;******************************************************************************
			;Obsluha klavesy SHIFT + <-- (BACKSPACE)
			;******************************************************************************
3012   81B3 21 36 C0	L81B3:	LD	HL,0C036h		;pozice kurzoru v bufferu
3013   81B6 35			DEC	(HL)
3014   81B7 F0			RET	P
3015   81B8 34			INC	(HL)

			;******************************************************************************
			;Obsluha klavesy CONT + -->
			;******************************************************************************
3016   81B9 21 38 C0		LD	HL,0C038h		;1 vypisovany znak z bufferu na obrazovku
3017   81BC 35			DEC	(HL)
3018   81BD F0			RET	P
3019   81BE 34			INC	(HL)
3020   81BF C9			RET

			;******************************************************************************
			;TEXTHEAD - prenos dlavicky souboru
			;******************************************************************************
3021   81C0 11 B8 C1	L0265:	LD	DE,0C1B8h		;8 znaku nazvu souboru
3022   81C3 06 08	L0258:	LD	B,008h			;delka nazvu souboru

			;******************************************************************************
			;TEXTSP - prenos textu z (HL) do (DE) s doplnenim mezer na delku B
			; vstup: HL= text koncici CR
			; DE= buffer pro cilovy text
			; B = max. pocet znaku
			; vyst.: prenese text, na konec doplni mezery
			; pozn.: k prenosu hlavicky HEAD se pouzije TEXTHEAD
			;******************************************************************************
3023   81C5 7E		L0039:	LD	A,(HL)			;vstupni znak
3024   81C6 FE 0D		CP	00Dh			;je konec textu?
3025   81C8 C2 CE 81		JP	NZ,L0038		;neni, skoc
3026   81CB 3E 20		LD	A,020h			;00Dh nahrad 020h
3027   81CD 2B			DEC	HL			;oprava ukazatele zdroje
3028   81CE 12		L0038:	LD	(DE),A			;vloz znak textu do bufferu
3029   81CF 23			INC	HL			;dalsi adresa zdroje textu
3030   81D0 13			INC	DE			;dalsi adresa pro ulozeni textu
3031   81D1 05			DEC	B			;pocitadlo pozadovane delky textu
3032   81D2 C2 C5 81		JP	NZ,L0039		;opakuj pro cely text
3033   81D5 C9			RET				;navrat

			;******************************************************************************
			;obsluha prikazu MONITORu JUMP
			;******************************************************************************
3034   81D6 2A 38 C1	L81D6:	LD	HL,(0C138h)		;navratova adresa pro JUMP
3035   81D9 E3			EX	(SP),HL
3036   81DA CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu
3037   81DD D5			PUSH	DE			;prectena adresa
3038   81DE 21 7D 82		LD	HL,0827Dh		;text '** EXECUTIVE **'
3039   81E1 CD 39 8B		CALL	L0041			;vypis hlaseni na obrazovku
3040   81E4 FB			EI				;povol preruseni
3041   81E5 C9			RET				;skok na adresu udanou za JUMP

			;******************************************************************************
			;obsluha prikazu MONITORu DUMP
			;******************************************************************************
3042   81E6 CD 4B 81	L81E6:	CALL	L0040			;RADR - vstupni hex konverze 16 bitu
3043   81E9 EB			EX	DE,HL			;adresa do HL
3044   81EA E5		L0051:	PUSH	HL			;prectena adresa
3045   81EB 7C			LD	A,H			;HIGH byte adresy
3046   81EC CD 25 81		CALL	L0042			;PERVOD1 - vypis Acc v hex na obrazovku
3047   81EF 7D			LD	A,L			;LOW byte adresy
3048   81F0 CD 25 81		CALL	L0042			;PERVOD1 - vypis Acc v hex na obrazovku
3049   81F3 CD FB 84		CALL	L0043			;zobrazeni mezery
3050   81F6 0E 08		LD	C,008h			;pocet byte vedle sebe na obrazovce
3051   81F8 CD FB 84	L0044:	CALL	L0043			;zobrazeni mezery
3052   81FB 7E			LD	A,(HL)			;cti byte k vypisu
3053   81FC CD 25 81		CALL	L0042			;PREVOD1 - vypis Acc v hex na obrazovku
3054   81FF 23			INC	HL			;adresa dalsiho byte k vypisu
3055   8200 0D			DEC	C			;pocet byte na radku
3056   8201 C2 F8 81		JP	NZ,L0044		;opakuj pro vsech 8 byte
3057   8204 0E 05		LD	C,005h			;oddeleni HEX a ASCII 5-ti mezerami
3058   8206 CD FB 84	L0045:	CALL	L0043			;zobrazeni mezery
3059   8209 0D			DEC	C			;pocet mezer
3060   820A C2 06 82		JP	NZ,L0045		;opakuj pro vsech 5 mezer
3061   820D 0E 08		LD	C,008h			;pocet byte vedle sebe na obrazovce
3062   820F E1			POP	HL			;obnov adresu ctenych dat
3063   8210 7E		L0047:	LD	A,(HL)			;cti byte k vypisu
3064   8211 E5			PUSH	HL			;schovej si adresu ctenych dat
3065   8212 CD 42 85		CALL	L0046			;uprava pozice kurzoru + WRCHAR
3066   8215 E1			POP	HL			;obnov si adresu ctenych dat
3067   8216 23			INC	HL			;dalsi adresa
3068   8217 0D			DEC	C			;pocet ASCII znaku na radku
3069   8218 C2 10 82		JP	NZ,L0047		;opakuj pro vsech 8 znaku
3070   821B DB F6	L0048:	IN	A,(0F6h)		;PC - cteni ridicich klaves
3071   821D E6 20		AND	020h			;klavesa SHIFT
3072   821F CA 1B 82		JP	Z,L0048			;je-li stiskunto SHIFT, cekej na uvolneni
3073   8222 CD FE 84		CALL	L0049			;odradkovani
3074   8225 CD 74 8C		CALL	L0050			;test klavesy STOP
3075   8228 C2 EA 81		JP	NZ,L0051		;neni stisknuta, vypis dalsiho radku
3076   822B CD 13 81		CALL	L0008			;obsluha klavesy CLL - vymaz celeho radku
3077   822E C3 54 80		JP	L0052			;navrat do hlavni smycky MAIN

			;******************************************************************************
			;Inicializacni data, prenasi se do zapisnikove oblasti (vedle VRAM)
			;******************************************************************************
			V8231:	DW	07F00h		;0C030h	- adresa editacniho buferu
				DW	0FFC0h		;0C032h	- adresa posledního TV radku
				DW	07F4Fh		;0C034h	- konec editacniho buferu
				DW	00000h		;0C036h - pozice kurzoru v buferu
				DW	07F00h		;0C038h - 1. vypisovany znak z buferu na obrazovku
				DB	000h		;0C03Ah	- atribut zobrazeni
				DB	045h		;0C03Bh	- pozice v bufferu pro pipnuti pred koncem radku
				DB	008h,086h
				DW	00000h		;0C03Eh - adresa kurzoru na obrazovce

				DW	07FFFh		;0C070h	- adresa vrcholu zasobniku
				DW	00000h		;0C072h	- nastaveni pri analyze bufferu
				DW	00000h		;0C074h	- zacatek textu hlaseni
				DW	00000h		;0C076h	- navratova adresa pro ENTER
				DW	07F82h		;0C078h	- adresa ulozeni textu po EOL v ENTER
				DW	00000h		;0C07Ah	- adresa zasobniku pro navrat z ENTER
				DB	020h		;0C07Ch	- konstanta rychlosti cteni z magnetofonu
				DB	000h		;0C07Dh
				DW	082EBh		;0C07E	- zacatek tabulky prikazu MONITORu - 1

				DB	000h,0FFh,008h,086h,008h,087h,0C8h,088h		;0C0B0h
				DB	000h,0FFh,000h,0FFh,000h,032h,000h,001h		;0C0B8h
				DB	000h,0C3h,0B2h,081h,0EAh,009h,0B0h,0FAh		;0C0F0h
				DB	000h,0FDh,0FBh,030h,040h,002h,030h,020h		;0C0F8h
				DB	0D2h,080h,0B0h,082h,000h,000h,000h,000h		;0C130h
				DB	03Bh,080h,052h,07Fh				;0C138h
			V827D:	DB	'** EXECUTIVE **',00Dh				;0C13Ch
			V828D:	DW	07F00h		;0C17Ch	- adresa klicu
				DW	07D00h		;0C17Eh	- radoby hranice klicu 
			V8291:	DB	'** ERROR IN DATA **',00Dh			;0C1B0h
			V82A5:		LD	A,(HL)	;0C1F4h - 07Eh
					CPI	03Fh	;0C1F5h	- 0FEh,03Fh
					CPI	000h	;0C1F7h - 0FEh,000h
					NOP		;0C1F9h	- 000h
					XOR	B	;0C1FAh - 0A8h 	- nebo AND B (0A0h) nebo OR B  (0B0h)
					NOP		;0C1FBh	- 000h
					LD	(HL),A	;C01FCh - 077h
					RET		;C01FDh - 0C9h
; nasledujuce dva bajty su urcene pre casovanie prenosu po sieti
				DB	00Ah,021h,000h

			;******************************************************************************
			;Tabulka podprogramu editacnich klaves
			;******************************************************************************
			V82B2:	DB	00Fh			;PTL - klavesa
				DW	L83C7			;adresa obsluzne rutiny
				DB	012h			;MON
				DW	L803B
				DB	00Bh			;WRK
				DW	L83C1
				DB	01Eh			;C-D
				DW	L889C
				DB	017h			;RCL
				DW	L8833
				DB	01Ch			;INST
				DW	L880D
				DB	01Dh			;DELT
				DW	L8D4D
				DB	01Bh			;CLL
				DW	L8113
				DB	008h			;SHIFT + <-- (BACKSPACE)
				DW	L81B3
				DB	00Ch			;BGNL (HOME)
				DW	L85F6
				DB	018h			;SHIFT + --> (INSERT)
				DW	L819F	
				DB	01Ah			;CONT + <--
				DW	L81A9
				DB	003h			;ENDL
				DW	L8B90
				DB	019h			;CONT + -->
				DW	L81B9
				DB	00Dh			;EOL
				DW	L8BB6
				DB	001h			;DELL
				DW	L8116
				DB	01Fh			;CLS
				DW	L85A7
				DB	00Ah			;INVR
				DW	L859F
				DB	010h			;BEEP
				DW	L8167
				DB	000h			;zarazka konce tabulky

			;******************************************************************************
			;Tabulka prikazu MONITORU
			;******************************************************************************
3237   82EC 53		V82EC:	DB	'SUB',000h		;'SUB' - prikaz MONITORu
				DW	L8A8F			;adresa obsluzne rutiny
3243   82F2 4D			DB	'MEM',000h
3247   82F6 87			DW	L8587
3249   82F8 4A			DB	'JUMP',000h
3254   82FD D6 81		DW	L81D6
3255   82FF 44			DB	'DUMP',000h
3260   8304 E6 81		DW	L81E6
3261   8306 4D			DB	'MGSV',000h
3266   830B 7F			DW	L8E7F
3268   830D 4D			DB	'MGLD',000h
3273   8312 73			DW	L8873
3275   8314 4D			DB	'MGEND',000h
3281   831A 79			DW	L8879
3283   831C 42			DB	'BASIC',000h
3289   8322 11 8F 		DW	L8F11
4A	      			DB	'JOB',000h
3293   8328 D7			DW	L8FD7
3295   832A 47			DB	'DEMO',000h
3298   832D 42			DW	L9000
3300   8331 44			DB	'READ',000h
3305   8334 05			DW	L9192
3307   8338 43			DB	'SEND',000h
3312   833B 01 90 FF		DW	L901D
				DB	'SET',000h
3312   833F 01 90 FF		DW	L95A6
3313   833E FF			DB	0FFh			;zarazka konce tabulky

			;******************************************************************************
			;Texty chybovych hlaseni
			;******************************************************************************
3317   8346 2B		V8346:	DB	'++ ERROR IN ADDRES ++',00Dh
3335   835C 2B		V835C:	DB	'++ FILE ERROR ++',00Dh
3349   836D 2A 2A 20	V836D:	DB	'** OS READY **',00Dh
3358   837A 2A 0D 2B	V837C:	DB	'++ MEMORY OVERFLOV ++',00Dh
3377   8392 2B		V8392:	DB	'++ NO COMMAND ++',00Dh

			;******************************************************************************
			;Volane od SUB - do editacniho buferu vlozi text 'SUB adresa', kurzor na 9. pozici
			;******************************************************************************
3391   83A3 D5		L0189:	PUSH	DE			;uklid adresy kam se ukadaji data
3392   83A4 CD 13 81	L0076:	CALL	L0008			;obsluha klavesy CLL - vymaz celeho radku
3393   83A7 D1			POP	DE
3394   83A8 2A 30 C0	L0115:	LD	HL,(0C030h)		;zacatek bufferu dialogoveho radku
3395   83AB 36 53		LD	(HL),053h		;'S'
3396   83AD 23			INC	HL			;dalsi adresa v buferu
3397   83AE 36 55		LD	(HL),055h		;'U'
3398   83B0 23			INC	HL			;dalsi adresa v buferu
3399   83B1 36 42		LD	(HL),042h		;'B'
3400   83B3 23			INC	HL			;dalsi adresa v buferu
3401   83B4 36 20		LD	(HL),020h		;' '
3402   83B6 23			INC	HL			;dalsi adresa v buferu
3403   83B7 7A			LD	A,D			;HIGH byte modifikovane adresy
3404   83B8 CD 3B 81		CALL	L0083			;PREVOD2 - konverze 8 bitu na hex s vlozenim do (HL)
3405   83BB 23		L0079:	INC	HL			;dalsi adresa v buferu
3406   83BC 3E 09		LD	A,009h			;pozice kurzoru v buferu - kam se bude psat
3407   83BE C3 37 81		JP	L0084			;nastaveni kurzoru, prevod LOW byte adresy

			;******************************************************************************
			;Obsluha klavesy WRK - priznak zapisu do klicu
			;******************************************************************************
3408   83C1 3E FF	L83C1:	LD	A,0FFh			;hodnota priznaku
3409   83C3 32 35 C1		LD	(0C135h),A		;priznak WRK
3410   83C6 C9			RET

			;******************************************************************************
			;Obsluha klavesy PTL - priznak rolovani dialogoveho radku
			;******************************************************************************
3411   83C7 21 37 C1	L83C7:	LD	HL,0C137h		;adresa priznaku PTL
3412   83CA 7E			LD	A,(HL)			;precti priznak
3413   83CB 2F			CPL				;proved inverzi
3414   83CC 77		L0082:	LD	(HL),A			;vrat na misto
3415   83CD C9			RET

			;******************************************************************************
			;Vypocet adresy bitmapy ASCII znaku v generátoru znaku. Adresa ukazuje na
			; 1. byte bitmapy nasledujiciho znaku. Adresa je v HL.
			;******************************************************************************
3416   83CE 26 00	L0110:	LD	H,000h			;ASCII kod znaku do HL
3417   83D0 6F			LD	L,A
3418   83D1 29			ADD	HL,HL			;*2 - vypocet offsetu v generatoru znaku
3419   83D2 29			ADD	HL,HL			;*4
3420   83D3 29			ADD	HL,HL			;*8 - bitmapa znaku zabira 8 byte
3421   83D4 EB			EX	DE,HL			;vysledek do DE
3422   83D5 FE 20		CP	020h			;je ASCII pod 020h (' ')
3423   83D7 DA EE 83		JP	C,L0085			;ano, skoc - tiskne se sachovnice
3424   83DA FE 60		CP	060h			;je ASCII nad 060h?
3425   83DC D2 E4 83	L0081:	JP	NC,L0080		;je, skoc
3426   83DF 21 08 85		LD	HL,08508h		;pocatek generatoru znaku-100h+8 byte 
3427   83E2 19			ADD	HL,DE			;spocti nasledujici byte za pozadovanym znakem
3428   83E3 C9			RET
3429   83E4 FE 97	L0080:	CP	097h			;je znak vetsi, nez 097h?
3430   83E6 D2 EE 83		JP	NC,L0085		;je, skoc - tiskne se sachovnice
3431   83E9 21 C6 85		LD	HL,085C6h		;pocatek 2. generatoru znaku-100h+8 byte
3432   83EC 19			ADD	HL,DE			;spocti nasledujici byte za pozadovanym znakem
3433   83ED C9			RET

3434   83EE 21 6E 8A	L0085:	LD	HL,08A6Eh		;1. byte za znakem sachovnice
3435   83F1 C9			RET

			;******************************************************************************
			;Mapovani kodu klavesnice
			;******************************************************************************
			V83F2:	DB	001h					;sloupec 000000001b
				DB	031h,051h,041h,059h,02Dh,050h,013h	;1  Q  A  Y  =	P  dn
				DB	000h					;zarazka
				DB	021h,071h,061h,079h,03Dh,070h,014h	;SHIFT+znak
				DB	000h					;zarazka
				DB	0D0h,080h,08Bh,00Bh,0DAh,089h,00Ah	;CONT+znak
				DB	000h					;zarazka
				DB	002h					;sloupec 000000010b
				DB	032h,057h,053h,058h,030h,02Fh,011h	;2  W  S  X  0	?  up
				DB	000h
				DB	022h,077h,073h,078h,05Fh,03Fh,009h
				DB	000h
				DB	0D1h,081h,08Ch,017h,0D9h,00Fh,00Ch
				DB	000h
				DB	004h					;sloupec 000000100b
				DB	033h,045h,044h,043h,05Ch,03Bh,020h	;3  E  D  C  ^	+ spc
				DB	000h
				DB	023h,065h,064h,063h,05Eh,02Bh,020h
				DB	000h
				DB	0D2h,082h,08Dh,01Eh,0DBh,094h,020h
				DB	000h
				DB	008h					;sloupec 000001000b
				DB	034h,052h,046h,056h,038h,039h,040h	;4  R  F  V  8	9  *
				DB	000h
				DB	024h,072h,066h,076h,028h,029h,060h
				DB	000h
				DB	0D3h,083h,08Eh,01Fh,0D7h,0D8h,08Ah
				DB	000h
				DB	010h					;sloupec 000010000b
				DB	035h,054h,047h,042h,02Ch,02Eh,008h	;5  T  G  B  ,	.  «
				DB	000h
				DB	025h,074h,067h,062h,03Ch,03Eh,01Ah
				DB	000h
				DB	0D4h,084h,08Fh,01Bh,012h,001h,010h
				DB	000h
				DB	020h					;sloupec 000100000b
				DB	036h,05Ah,048h,04Eh,04Bh,04Ch,018h	;6  Z  H  N  K	L  »
				DB	000h
				DB	026h,07Ah,068h,06Eh,06Bh,06Ch,019h
				DB	000h
				DB	0D5h,085h,090h,01Dh,092h,093h,003h
				DB	000h
				DB	040h					;sloupec 001000000b
				DB	037h,055h,04Ah,04Dh,049h,04Fh,03Ah	;7  U  J  M  I	O  *
				DB	000h
				DB	027h,075h,06Ah,06Dh,069h,06Fh,02Ah
				DB	000h
				DB	0D6h,086h,091h,01Ch,087h,088h,095h
				DB	000h

			;******************************************************************************
			;INKLAV - nacteni znaku z klavesnice s cekanim na stisk
			; vstup: SBEEP 0C0BFh = ma / nema pri stisku klavesy puknout
			; vyst.: A= ASCII kod klavesy, vola SCAN 08C03h
			; znici: PSW
			;******************************************************************************
3577   84A1 C5		L0010:	PUSH	BC			;uklid registru
3578   84A2 E5			PUSH	HL
3579   84A3 21 BD C0		LD	HL,0C0BDh
3580   84A6 4E			LD	C,(HL)			;C=032h
3581   84A7 36 32	L0096:	LD	(HL),032h
3582   84A9 2B			DEC	HL			;HL=0C0BCh
3583   84AA 3E 03	L0100:	LD	A,003h			;konstanta pro cekani mezi jednotlivymi ctenimi
; tu je zmena oproti povodnej ROM, rutina casovej premlky je inovovana
3584   84AC CD 1B 8C		CALL	L9220			;casova prodleva
3585   84AF CD 03 8C		CALL	L0099			;SCAN - letmy test klavesnice
3586   84B2 46			LD	B,(HL)			;0C0BC - predchozi scan klavesnice
3587   84B3 77			LD	(HL),A			;vloz aktualni scan klavesnice
3588   84B4 CA AA 84		JP	Z,L0100			;pokud nebylo nic stisknuto, skoc
3589   84B7 B8			CP	B			;porovnej predchozi a soucasny scan
3590   84B8 C2 27 8C		JP	NZ,L0101		;puknuti klavesnice
3591   84BB 0D			DEC	C			;pocet scanovani klavesnice, nez je znak uznan
3592   84BC C2 AA 84		JP	NZ,L0100		;opakuj scanovani klavesnice
3593   84BF 23			INC	HL			;HL=0C0BDh
3594   84C0 C3 25 8C		JP	L0102			;pipnuti, obnoveni registru, ulozeni precteneho znaku

			;******************************************************************************
			;pokracovani SCAN, potazmo INKLAV - prevod scan kodu na kod klavesy
			;******************************************************************************
3595   84C3 4F		L0216:	LD	C,A			;precteny sloupec klavesnice
3596   84C4 17			RLA				;MSB bit do CY
3597   84C5 3E 0D		LD	A,00Dh			;priprava na stisk EOL
3598   84C7 DA F5 84		JP	C,L0103			;CY=1=EOL, skoc - obnova registru, ulozeni kodu klavesy
3599   84CA 78			LD	A,B			;zbyvajici pocet radku klavesnice
3600   84CB 2F			CPL				;dvojovy doplnek
3601   84CC E6 07		AND	007h			;je jen 7 radku, zbytek odmaskuj
3602   84CE 47			LD	B,A			;poradove cislo radku se stisknutou klavesou
3603   84CF E5			PUSH	HL			;uklid registru
3604   84D0 D5			PUSH	DE
3605   84D1 11 19 00		LD	DE,00019h
3606   84D4 21 D9 83		LD	HL,083D9h		;HL+DE=V84F2 - dekodovaci tabulka klavesnice
3607   84D7 19		L0105:	ADD	HL,DE			;posun na dalsi sloupec v tabulce
3608   84D8 7E			LD	A,(HL)			;cti z tabulky sloupec 
3609   84D9 B7			OR	A			;test na konec prevodni tabulky
3610   84DA CA F3 84		JP	Z,L0104			;tabulka je precteny cela, konec
3611   84DD B9			CP	C			;je jiz pozadovany sloupec?
3612   84DE C2 D7 84		JP	NZ,L0105		;neni, dalsi sloupec
3613   84E1 23			INC	HL			;posun na vlastni data
3614   84E2 DB F6		IN	A,(0F6h)		;cteni klaves SHIFT a CONT
3615   84E4 2F			CPL				;dvojkovy doplnek
3616   84E5 1F			RRA				;posun o 2 bity vpravo
3617   84E6 1F			RRA				;SHIFT je o 8 a CONT o 16 byte v tabulce dal
3618   84E7 E6 18		AND	018h			;oddmaskuj jen SHIFT a CONT
3619   84E9 FE 18		CP	018h
3620   84EB C2 EF 84		JP	NZ,L0106		;bylo-li SHIFT nebo CONT, skoc
3621   84EE AF			XOR	A			;nebylo nic, nuluj Acc
3622   84EF 80		L0106:	ADD	A,B			;vypocet posunuti s radkem a SHIFT nebo CONT
3623   84F0 5F			LD	E,A			;uprav posun v tabulce o 0, 8 16 byte
3624   84F1 19			ADD	HL,DE			;vypocet adresy kodu klavesy
3625   84F2 7E			LD	A,(HL)			;cti kod klavesy jiz se SHIFT a CONT
3626   84F3 D1		L0104:	POP	DE			;obnoveni registru
3627   84F4 E1		L0220:	POP	HL
3628   84F5 C1		L0103:	POP	BC
3629   84F6 32 34 C1		LD	(0C134h),A		;znak nacteny z klavesnice z INKLAV
3630   84F9 B7			OR	A			;nastaveni, zda bylo neco precteno
3631   84FA C9			RET

3632   84FB 3E 20	L0043:	LD	A,020h			;zobrazeni mezery

3633   84FD 11 		V84FD:	DB	011h			;LD	DE,0D3Eh

			L0049:	LD	A,00Dh			;odradkovani

			;******************************************************************************
			;PRTOUT - vypis znaku do obrazovky
			; vstup: CURSOR 0C03Eh= pozice kurzoru, A= znak: 01Ch= CLS,
			; 00Dh= novy radek, 00Ah= ignorovat, 008h= kurzor o pozici zpet
			; COLOR 0C03Ah= atribut vypisu znaku - polojas, blikani
			; vyst.: vola WRCHAR 0854Ah
			; znici: PSW
			;******************************************************************************
3634   8500 C5		L0030:	PUSH	BC			;uklid registru
3635   8501 D5			PUSH	DE
3636   8502 E5			PUSH	HL
3637   8503 21 75 85		LD	HL,08575h		;adresa navratu - 3xPOP + RET
3638   8506 E5			PUSH	HL			;nastav navrat
3639   8507 FE 0D		CP	00Dh			;je novy radek?
3640   8509 C2 23 85		JP	NZ,L0107		;neni - skoc
3641   850C 2A 3E C0		LD	HL,(0C03Eh)		;adresa kurzoru na obrazovce
3642   850F 3A FA C0		LD	A,(0C0FAh)		;VYSKA=0FBh vyska obrazovky v mikroradcich
3643   8512 BC			CP	H			;je pozice kurzoru dal, nez je vyska obrauovky
3644   8513 DA 88 80	L0724:	JP	C,L0108			;ROLL - posun obrazu smerem vzhuru o 1 radek
3645   8516 7D			LD	A,L
3646   8517 E6 C0		AND	0C0h			;pocatek radku 
3647   8519 6F			LD	L,A
3648   851A EB			EX	DE,HL
3649   851B 2A FC C0		LD	HL,(0C0FCh)		;roztec radku
3650   851E 19			ADD	HL,DE			;spocti novou pozici kurzoru
3651   851F 22 3E C0		LD	(0C03Eh),HL		;adresa kurzoru na obrazovce
3652   8522 C9			RET				;odradkovano, navrat
3653   8523 FE 1C	L0107:	CP	01Ch			;je prikaz smazani obrazovky?
3654   8525 CA A7 85		JP	Z,L0109			;ano - skoc na smazani obrazovky
3655   8528 FE 0A		CP	00Ah			;ignorovat znak?
3656   852A C8			RET	Z			;ano - navrat
3657   852B A7			AND	A			;je Acc=0?
3658   852C C8			RET	Z			;ano, navrat
3659   852D 21 3E C0		LD	HL,0C03Eh		;adresa kurzoru na obrazovce
3660   8530 35			DEC	(HL)			;proved BACKSPACE
3661   8531 FE 08		CP	008h			;test na BACKSPACE
3662   8533 C8			RET	Z			;ano, je - navrat
3663   8534 34			INC	(HL)			;BACKSPACE nebylo, vrat kurzor zpatky
3664   8535 4F			LD	C,A			;odloz si znak k zobrazeni
3665   8536 7E			LD	A,(HL)			;adresa kurzoru na obrazovce
3666   8537 E6 3F		AND	03Fh			;odmaskuj
3667   8539 47			LD	B,A			;dej do B
3668   853A 3A FB C0		LD	A,(0C0FBh)		;ENLNW=30h - pocet znaku na radku
3669   853D B8			CP	B			;pokud jsme na konci radku, odradkuj
3670   853E CC FE 84		CALL	Z,L0049			;odradkovani
3671   8541 79			LD	A,C			;obnov znak k zobrazeni
3672   8542 21 3E C0	L0046:	LD	HL,0C03Eh		;adresa kurzoru na obrazovce
3673   8545 34			INC	(HL)			;uprav adresu kurzoru na novou pozici
3674   8546 2A 3E C0		LD	HL,(0C03Eh)		;adresa kurzoru na obrazovce
3675   8549 2B			DEC	HL			;vrat na puvodni hodnotu

			;******************************************************************************
			; WRCHAR - rozkresleni znaku do displeje
			; vstup: HL= adresa kurzoru 2 linky pod znakem
			; A= kod znaku: netisknutelny znak= vypise sachovnici 095h
			; COLOR 0C03Ah= atribut vypisu znaku - polojas, blikani
			; vyst.: rozkresli znak, nelze pouzit s povolenym prerusenim !
			;******************************************************************************
3676   854A C5		L0114:	PUSH	BC			;uklid registru
3677   854B D5			PUSH	DE
3678   854C E5			PUSH	HL			;adresa kurzoru
3679   854D CD CE 83		CALL	L0110			;vraci adresu 1. byte za pozadovanym znakem z generatoru znaku
3680   8550 EB			EX	DE,HL			;v DE je adresa v generatoru znaku
3681   8551 21 00 00		LD	HL,00000h		;zaloha SP
3682   8554 39			ADD	HL,SP
3683   8555 22 3E C1		LD	(0C13Eh),HL		;misto pro odkladani ukazatele zasobniku
3684   8558 3A 3A C0		LD	A,(0C03Ah)		;atribut zobrazeni
3685   855B E1			POP	HL			;adresa kurzoru
3686   855C E5			PUSH	HL
3687   855D 31 C0 FF		LD	SP,0FFC0h		;vzdalenost mikroradku v RAM
3688   8560 01 80 FF		LD	BC,0FF80h		;zacina se na 2. mikroradku nad kurzorem
3689   8563 09			ADD	HL,BC			;adresa VRAM, kam se bude ukladat bitmapa
3690   8564 47			LD	B,A			;atribut zobrazeni
3691   8565 0E 08		LD	C,008h			;vyska je 8 mikroradku
3692   8567 1B		L0111:	DEC	DE			;posun v generatoru znaku o byte zpet
3693   8568 1A			LD	A,(DE)			;bitmapa mikroradku znaku
3694   8569 A8			XOR	B			;kombinace s atributem zobrazeni
3695   856A 77			LD	(HL),A			;zapis do VRAM
3696   856B 39			ADD	HL,SP			;HL=HL-040h - vzdalenost mikroradku ve VRAM
3697   856C 0D			DEC	C			;citac mikroradku
3698   856D C2 67 85		JP	NZ,L0111		;opakuj pro vsech 8 mikroradku
3699   8570 70			LD	(HL),B			;prazdny mikroradek s atributy
3700   8571 2A 3E C1		LD	HL,(0C13Eh)		;misto pro odkladani ukazatele zasobniku
3701   8574 F9			LD	SP,HL			;obnoveni SP
3702   8575 E1			POP	HL			;obnoveni registru
3703   8576 D1			POP	DE
3704   8577 C1		L0250:	POP	BC
3705   8578 C9			RET

			;******************************************************************************
			; SYST1 - provedeni prikazu MONITORu
			;******************************************************************************
3706   8579 CD 24 8F	L0014:	CALL	L0112			;ignorovani mezer v editacnim radku
3707   857C 22 72 C0		LD	(0C072h),HL		;nastaveni pri analyze bufferu
3708   857F 13			INC	DE			;posun na adresu obsluhy prikazu
3709   8580 EB			EX	DE,HL
3710   8581 C3 66 8C		JP	L0113			;precteni adresy z buferu a skok na ni

3711   8584 C3 4A 85		JP	L0114			; WRCHAR - rozkresleni znaku do displeje

			;******************************************************************************
			;obsluha prikazu MONITORu MEM
			;******************************************************************************
3712   8587 CD 4B 81	L8587:	CALL	L0040			;RADR - vstupni hex konverze 16 bitu
3713   858A CD A8 83		CALL	L0115			;vypsani 'SUB adresa'
3714   858D 06 10		LD	B,010h			;zobrazuje se 10h byte (hex znaku)
3715   858F C5		L0116:	PUSH	BC			;schovej si pocidadlo zobrazovanych byte
3716   8590 23			INC	HL			;dalsi pozice v editacnim buferu
3717   8591 36 20		LD	(HL),020h		;vloz mezeru
3718   8593 23			INC	HL			;dalsi pozice v editacnim buferu
3719   8594 1A			LD	A,(DE)			;cty zobrazovany byte z pameti
3720   8595 CD 3B 81		CALL	L0083			;PREVOD2 - konverze 8 bitu na 2*hex
3721   8598 13			INC	DE			;dalsi byte v pameti
3722   8599 C1			POP	BC			;pocitadlo byte na radku
3723   859A 05			DEC	B			;sniz pocitadlo
3724   859B C2 8F 85		JP	NZ,L0116		;zobraz vsech 10h hex hodnot z pameti
3725   859E C9			RET

			;******************************************************************************
			;Obsluha klavesy INVR
			;MODNEG - zapnuti/vypnuti inverzniho tisku + vymaz obrazovky
			; vyst.: COLOR 0C03Ah, vola ERASE 085A7h
			;******************************************************************************
3726   859F 3A 3A C0	L859F:	LD	A,(0C03Ah)		;barevne atributy
3727   85A2 EE 3F		XOR	03Fh			;zapni/vypni inverzni zobrazeni
3728   85A4 32 3A C0		LD	(0C03Ah),A		;vrat zpatky barevne atributy

			;******************************************************************************
			;Obsluha klavesy CLS
			;ERASE - smazani obrazovky
			; vstup: COLOR C03A= cim mazat
			; vyst.: vola SWIND 085B3h
			;******************************************************************************
3729   85A7 01 80 C2	L0109:	LD	BC,0C280h
3730   85AA 11 30 C0		LD	DE,0C030h		;pri PUSH se SP snizuje - konec 1. mikroradku
3731   85AD 2A FC C0		LD	HL,(0C0FCh)		;roztec radku
3732   85B0 09			ADD	HL,BC
3733   85B1 06 00		LD	B,000h			;256 mikroradku

			;******************************************************************************
			;SWIND - vymazani casti obrazovky - okno
			; vstup: HL= adr. kurzoru
			; DE= konec nejvyssi mazane linky+1
			; B= pocet mazanych linek
			;******************************************************************************
3734   85B3 22 3E C0	L0021:	LD	(0C03Eh),HL		;adresa kurzoru ve VRAM
3735   85B6 3A 3A C0		LD	A,(0C03Ah)		;barevne atributy
3736   85B9 21 00 00		LD	HL,00000h		;nuluj HL
3737   85BC 39			ADD	HL,SP			;kopie SP do HL
3738   85BD EB			EX	DE,HL			;v DE je nyni puvodni SP, v HL konec 1. mikroradku
3739   85BE F9			LD	SP,HL			;konec 1. mikroradku
3740   85BF 4F			LD	C,A
3741   85C0 78			LD	A,B
3742   85C1 41			LD	B,C
3743   85C2 C5		L0117:	PUSH	BC			;smazani mikroradku
3744   85C3 C5			PUSH	BC			;24 x 2 byte = 48 byte ve VRAM
3745   85C4 C5			PUSH	BC
3746   85C5 C5			PUSH	BC
3747   85C6 C5			PUSH	BC
3748   85C7 C5			PUSH	BC
3749   85C8 C5			PUSH	BC
3750   85C9 C5			PUSH	BC
3751   85CA C5			PUSH	BC
3752   85CB C5			PUSH	BC
3753   85CC C5			PUSH	BC
3754   85CD C5			PUSH	BC
3755   85CE C5			PUSH	BC
3756   85CF C5			PUSH	BC
3757   85D0 C5			PUSH	BC
3758   85D1 C5			PUSH	BC
3759   85D2 C5			PUSH	BC
3760   85D3 C5			PUSH	BC
3761   85D4 C5			PUSH	BC
3762   85D5 C5			PUSH	BC
3763   85D6 C5			PUSH	BC
3764   85D7 C5			PUSH	BC
3765   85D8 C5			PUSH	BC
3766   85D9 C5			PUSH	BC
3767   85DA 31 40 00		LD	SP,00040h		;offset jednotlivych mikroradku
3768   85DD 39			ADD	HL,SP			;konec dalsiho mikroradku
3769   85DE F9			LD	SP,HL			;vysledek do SP
3770   85DF 3D			DEC	A			;pocitadlo mikroradku
3771   85E0 C2 C2 85		JP	NZ,L0117		;opakuj pro vsechny mikroradky
3772   85E3 EB			EX	DE,HL			;obsah SP do HL
3773   85E4 F9			LD	SP,HL			;obnov si SP
3774   85E5 C9			RET				;navrat

			;******************************************************************************
			;RPOINT - test rozsviceni bodu obrazovky
			; vstup: X1 0C170h, Y1 0C172h = souradnice bodu ve VRAM
			; vyst.: Z, A=0 nesviti
			;	 NZ, A=1 sviti
			;******************************************************************************
3775   85E6 2A 71 C1		LD	HL,(0C171h)		;souradnice Y pocatecniho bodu
3776   85E9 3A 70 C1		LD	A,(0C170h)		;souradnice X pocatecniho bodu
3777   85EC 6F			LD	L,A
3778   85ED CD 94 8C		CALL	L0118			;POSPOINT - vypocet bodu na obrazovce + bitova maska vykresleni
3779   85F0 7E			LD	A,(HL)			;cti byte z VRAM
3780   85F1 A0			AND	B			;test na konkretni bit
3781   85F2 C8			RET	Z			;nesviti, navrat
3782   85F3 3E 01		LD	A,001h			;sviti, nastav Acc
3783   85F5 C9			RET

			;******************************************************************************
			;HOME - obsluha klavesy BNGL - posun na zacatek radku
			;******************************************************************************
3784   85F6 AF		L0026:	XOR	A			;nulovani pozic v editacnim radku
3785   85F7 32 38 C0		LD	(0C038h),A		;1 vypisovany znak z bufferu na obrazovku
3786   85FA 32 36 C0		LD	(0C036h),A		;pozice kurzoru v bufferu
3787   85FD C9			RET

3788   85FE 00		V85FE:	DB	000h,000h

			;******************************************************************************
			;Tabulka generatoru znaku 020h-05Fh
			;******************************************************************************
			V8600:	DB	000h,000h,000h,000h,000h,000h,000h,000h		;' '
				DB	008h,008h,008h,008h,000h,000h,008h,000h		;'!'
				DB	014h,014h,000h,000h,000h,000h,000h,000h		;'"'
				DB	014h,014h,03Eh,014h,03Eh,014h,014h,000h		;'#'
				DB	008h,03Ch,00Ah,01Ch,028h,01Eh,008h,000h		;'$'
				DB	006h,026h,010h,008h,004h,032h,030h,000h		;'%'
				DB	008h,014h,014h,00Ch,02Ah,012h,02Ch,000h		;'&'
				DB	008h,008h,004h,000h,000h,000h,000h,000h		;'''
				DB	008h,004h,002h,002h,002h,004h,008h,000h		;'('
				DB	008h,010h,020h,020h,020h,010h,008h,000h		;')'
				DB	000h,008h,02Ah,01Ch,02Ah,008h,000h,000h		;'*'
				DB	000h,008h,008h,03Eh,008h,008h,000h,000h		;'+'
				DB	000h,000h,000h,000h,008h,008h,004h,000h		;','
				DB	000h,000h,000h,03Ch,000h,000h,000h,000h		;'-'
				DB	000h,000h,000h,000h,000h,000h,008h,000h		;'.'
				DB	000h,020h,010h,008h,004h,002h,000h,000h		;'/'
				DB	01Ch,022h,032h,02Ah,026h,022h,01Ch,000h		;'0'
				DB	008h,00Ch,008h,008h,008h,008h,01Ch,000h		;'1'
				DB	01Ch,022h,020h,018h,004h,002h,03Eh,000h		;'2'
				DB	03Eh,020h,010h,038h,020h,022h,01Ch,000h		;'3'
				DB	010h,018h,014h,012h,03Eh,010h,010h,000h		;'4'
				DB	03Eh,002h,01Eh,020h,020h,022h,01Ch,000h		;'5'
				DB	038h,004h,002h,01Eh,022h,022h,01Ch,000h		;'6'
				DB	03Eh,020h,010h,008h,004h,004h,004h,000h		;'7'
				DB	01Ch,022h,022h,01Ch,022h,022h,01Ch,000h		;'8'
				DB	01Ch,022h,022h,03Ch,020h,010h,00Eh,000h		;'9'
				DB	000h,000h,000h,008h,000h,008h,000h,000h		;':'
				DB	000h,000h,008h,000h,008h,008h,004h,000h		;';'
				DB	010h,008h,004h,002h,004h,008h,010h,000h		;'<'
				DB	000h,000h,000h,03Eh,000h,03Eh,000h,000h		;'='
				DB	004h,008h,010h,020h,010h,008h,004h,000h		;'>'
				DB	01Ch,022h,020h,010h,008h,000h,008h,000h		;'?'
				DB	01Ch,022h,032h,02Ah,03Ah,002h,01Ch,000h		;'@'
				DB	008h,014h,022h,022h,03Eh,022h,022h,000h		;'A'
				DB	01Eh,022h,022h,01Eh,022h,022h,01Eh,000h		;'B'
				DB	01Ch,022h,002h,002h,002h,022h,01Ch,000h		;'C'
				DB	01Eh,024h,024h,024h,024h,024h,01Eh,000h		;'D'
				DB	01Eh,002h,002h,01Eh,002h,002h,01Eh,000h		;'E'
				DB	03Eh,002h,002h,01Eh,002h,002h,002h,000h		;'F
				DB	01Ch,002h,002h,002h,032h,022h,03Ch,000h		;'G'
				DB	022h,022h,022h,03Eh,022h,022h,022h,000h		;'H'
				DB	01Ch,008h,008h,008h,008h,008h,01Ch,000h		;'I'
				DB	020h,020h,020h,020h,022h,022h,01Ch,000h		;'J'
				DB	022h,012h,00Ah,006h,00Ah,012h,022h,000h		;'K'
				DB	002h,002h,002h,002h,002h,002h,03Eh,000h		;'L'
				DB	022h,036h,02Ah,02Ah,022h,022h,022h,000h		;'M'
				DB	022h,022h,026h,02Ah,032h,022h,022h,000h		;'N'
				DB	01Ch,022h,022h,022h,022h,022h,01Ch,000h		;'O'
				DB	01Eh,022h,022h,01Eh,002h,002h,002h,000h		;'P'
				DB	01Ch,022h,022h,022h,02Ah,012h,02Ch,000h		;'Q'
				DB	01Eh,022h,022h,01Eh,00Ah,012h,022h,000h		;'R'
				DB	01Ch,022h,002h,01Ch,020h,022h,01Ch,000h		;'S'
				DB	03Eh,008h,008h,008h,008h,008h,008h,000h		;'T'
				DB	022h,022h,022h,022h,022h,022h,01Ch,000h		;'U'
				DB	022h,022h,022h,014h,014h,008h,008h,000h		;'V'
				DB	022h,022h,022h,02Ah,02Ah,02Ah,014h,000h		;'W'
				DB	022h,022h,014h,008h,014h,022h,022h,000h		;'X'
				DB	022h,022h,014h,008h,008h,008h,008h,000h		;'Y'
				DB	03Eh,020h,010h,008h,004h,002h,03Eh,000h		;'Z'
				DB	00Eh,002h,002h,002h,002h,002h,00Eh,000h		;'['
				DB	000h,002h,004h,008h,010h,020h,000h,000h		;'\'
				DB	038h,020h,020h,020h,020h,020h,038h,000h		;']'
				DB	01Ch,022h,000h,000h,000h,000h,000h,000h		;'^'
				DB	000h,000h,000h,000h,000h,000h,03Eh,000h		;'_'

			;******************************************************************************
			;EDIT - provedeni zmeny v editacnim radku
			; vstup: ASCII 0C134h= kod znaku nebo povelu
			; vyst.: zmeneny editacni buffer je vypsan na obrazovku
			;******************************************************************************
4149   8800 C5		L0207:	PUSH	BC
4150   8801 D5			PUSH	DE
4151   8802 E5			PUSH	HL
4152   8803 21 75 85		LD	HL,08575h		;odkaz na 3xPOP a RET
4153   8806 E5		L0141:	PUSH	HL
4154   8807 CD 43 8C		CALL	L0011			;DOKEY - provedeni zmeny v editacnim bufferu
4155   880A C3 55 88	L0142:	JP	L0012			;WRLINE - vypis editacniho bufferu do dialogoveho radku

			;******************************************************************************
			;Obsluha klavesy INST
			;******************************************************************************
4156   880D CD 5E 81	L880D:	CALL	L0027			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
4157   8810 4D			LD	C,L
4158   8811 CD 46 8B		CALL	L0146			;ENDLN - vyhledani posledniho znaku v editacnim bufferu
4159   8814 54			LD	D,H			;vysledek do DE
4160   8815 5D			LD	E,L
4161   8816 13			INC	DE
4162   8817 79			LD	A,C
4163   8818 BB			CP	E
4164   8819 D0			RET	NC
4165   881A 7E		L0147:	LD	A,(HL)
4166   881B 12			LD	(DE),A
4167   881C 79			LD	A,C
4168   881D BD			CP	L
4169   881E 2B			DEC	HL
4170   881F 1B			DEC	DE
4171   8820 C2 1A 88		JP	NZ,L0147
4172   8823 23			INC	HL
4173   8824 36 20		LD	(HL),020h
4174   8826 C9			RET

			;******************************************************************************
			;Obsluha cteni/ukladani klicu K0..K11
			;******************************************************************************
4175   8827 3A 34 C1	L0224:	LD	A,(0C134h)		;znak nacteny z klavesnice z INKLAV
4176   882A 4F			LD	C,A			;schovej si znak z klavesnice
4177   882B 3A 35 C1		LD	A,(0C135h)		;priznak WRK
4178   882E B7			OR	A			;je WRK nastaven?
4179   882F C2 C2 8A		JP	NZ,L0148		;ano je, skoc - klic se bude ukladat
			V8832:	DB	032h			;kod instrukce LD (0870Eh),A
4180   8832 32 0E 87	L8833:	LD	C,087h			;CONT+I
4181   8835 2A 7C C1		LD	HL,(0C17Ch)		;adresa klicu
4182   8838 2B		L0149:	DEC	HL			;
4183   8839 7E			LD	A,(HL)			;byte z tabulky
4184   883A B7			OR	A			;konec seznamu?
4185   883B C8			RET	Z			;ano, navrat
4186   883C B9			CP	C			;je pozadovana klavesa?
4187   883D C2 38 88		JP	NZ,L0149		;neni, kontroluj dalsi znak
4188   8840 2B		L0151:	DEC	HL			;pozadovana klavesa nalezena
4189   8841 7E			LD	A,(HL)			;znak z klice
4190   8842 B7			OR	A			;je klic prazdny?
4191   8843 C8			RET	Z			;je, navrat
4192   8844 32 34 C1		LD	(0C134h),A		;znak nacteny z klavesnice z INKLAV
4193   8847 F2 4D 88		JP	P,L0150			;znak mensi nez 080h, skoc
4194   884A FE E0		CP	0E0h			;je znak mensi nez 0E0h
4195   884C D8			RET	C			;je, navrat
4196   884D E5		L0150:	PUSH	HL			;schovej si ukazatel
4197   884E CD 43 8C		CALL	L0011			;DOKEY - provedeni zmeny v editacnim bufferu
4198   8851 E1			POP	HL			;obnov si ukazatel
4199   8852 C3 40 88		JP	L0151			;dalsi znak z oblasti klicu

			;******************************************************************************
			;WRLINE - vypis editacniho bufferu do dialogoveho radku
			; vstup: RPOS 0C038h prvni vypisovany znak
			; DIAL 0C032h pozice pro vypis na obrazovce
			; DLZR 0C0FEh pocet znaku pro vypis
			;******************************************************************************
4200   8855 2A 38 C0	L0012:	LD	HL,(0C038h)		;1 vypisovany znak z bufferu na obrazovku
4201   8858 EB		L0157:	EX	DE,HL
4202   8859 2A 32 C0		LD	HL,(0C032h)		;zacatek vypisu dial. radku na obrazovce
4203   885C 3A FE C0		LD	A,(0C0FEh)		;pocet znaku pro vypis edit bufferu
4204   885F 47			LD	B,A			;v B je pocet znaku k zobrazeni
4205   8860 1A		L0152:	LD	A,(DE)			;znak z editacniho buferu
4206   8861 CD 4A 85		CALL	L0114			;WRCHAR - rozkresleni znaku do displeje
4207   8864 23			INC	HL			;dalsi pozice dialogoveho radku
4208   8865 13			INC	DE			;adresa dalsiho znaku v buferu
4209   8866 05			DEC	B			;delka retezce v buferu
4210   8867 C2 60 88		JP	NZ,L0152		;zobraz cely bufer
4211   886A C9			RET				;navrat

			;******************************************************************************
			;PREVOD0 - vystupni hex konverze 4 bity
			; vstup: A= bity 0..3= cislo
			; vyst.: A= hex.
			;******************************************************************************
4212   886B E6 0F	L0029:	AND	00Fh
4213   886D FE 0A		CP	00Ah
4214   886F DE 2F		SBC	A,02Fh
4215   8871 27			DAA
4216   8872 C9			RET

			;******************************************************************************
			;obsluha prikazu MONITORu MGLD
			;******************************************************************************
4217   8873 3A 36 C1	MGLD:	LD	A,(0C136h)		;typ souboru pro MGSV, MGLD, MGEND
4218   8876 C3 7A 88		JP	L0153

			;******************************************************************************
			;obsluha prikazu MONITORu MGEND
			;******************************************************************************
4219   8879 AF		L8879:	XOR	A
4220   887A 32 B1 C1	L0153:	LD	(0C1B1h),A		;pozadovany typ souboru
4221   887D CD 3E 8E		CALL	L0154			;DECPAR - nacteni cisla souboru
4222   8880 DA 49 80		JP	C,L0032			;navrat do MONITORu, vypis chyboveho hlaseni
4223   8883 32 B0 C1		LD	(0C1B0h),A		;pozadovane cislo souboru
4224   8886 CD E2 8D		CALL	L0155			;SHEAD - vyhledani a nacteni souboru z magnetofonu
4225   8889 C2 46 80		JP	NZ,L0016		;obsluha CLL, zprava NO COMMAND, opakovani smycky monitoru
4226   888C DA 46 80		JP	C,L0016			;obsluha CLL, zprava NO COMMAND, opakovani smycky monitoru
4227   888F 3A B1 C1		LD	A,(0C1B1h)		;pozadovany typ souboru
4228   8892 B7			OR	A			;test na nenulovost
4229   8893 CA 46 80		JP	Z,L0016			;obsluha CLL, zprava NO COMMAND, opakovani smycky monitoru
4230   8896 C3 6E 8A		JP	L0156			;test na ochranu souboru

4231   8899 00		V8899:	DB	000h,000h

4233   889B E5		L0202:	PUSH	HL
			;******************************************************************************
			;Obsluha klavesy C-D
			;******************************************************************************
4234   889C E1		L889C:	POP	HL
4235   889D 2A 3A C1		LD	HL,(0C13Ah)		;adr. C-D bufferu
4236   88A0 C3 58 88		JP	L0157

			;******************************************************************************
			;BEEP - standardni pipnuti
			; vstup: BEEDT 0C130h adresa tabulky pipnuti
			; vyst.: vola BELL 088A6h
			;******************************************************************************
4237   88A3 2A 30 C1	L0037:	LD	HL,(0C130h)		;adresa tabulky standardniho pipnuti pro BEEP

			;******************************************************************************
			;BELL - generuje tony podle tabulky
			; vstup: HL= adresa tabulky /delka,vyska,....,delka,vyska,0FFh/
			; vyst.: zahraje melodii podle tabulky
			;******************************************************************************
4238   88A6 7E		L88A6:	LD	A,(HL)			;cti data z pameti - delka tonu
4239   88A7 FE FF		CP	0FFh			;test na 0FFh - konec dat
4240   88A9 C8			RET	Z			;pokud byl konec dat, navrat
4241   88AA 47			LD	B,A			;zkopiruj delku tonu
4242   88AB 23			INC	HL			;dalsi pozice v pameti
4243   88AC 56			LD	D,(HL)			;cti vysku tonu
4244   88AD 23			INC	HL			;dalsi pozice v pameti
4245   88AE CD 70 81		CALL	L0158			;vlastni generovaní tonu
4246   88B1 C3 A6 88		JP	L88A6			;opakuj pro celu tabulku

4247   88B4 00		V88B4:	DB	000h,01Dh,0C2h,0B5h

			;******************************************************************************
			;Tabulka generatoru znaku 060h-07Fh
			;******************************************************************************
			V88B8:	DB	088h,015h,0C2h,0B5h,088h,0C9h,004h,008h		;'`'
				DB	000h,000h,000h,000h,000h,000h,000h,000h		;'a'
				DB	00Ch,010h,01Ch,012h,01Ch,000h,002h,002h		;'b'
				DB	00Eh,012h,012h,012h,00Eh,000h,000h,000h		;'c'
				DB	00Ch,012h,002h,012h,00Ch,000h,010h,010h		;'d'
				DB	01Ch,012h,012h,012h,01Ch,000h,000h,000h		;'e'
				DB	00Ch,012h,01Eh,002h,00Ch,000h,008h,014h		;'f'
				DB	004h,00Eh,004h,004h,004h,000h,000h,000h		;'g'
				DB	00Ch,012h,012h,01Ch,010h,00Eh,002h,002h		;'h'
				DB	00Eh,012h,012h,012h,012h,000h,008h,000h		;'i'
				DB	00Ch,008h,008h,008h,01Ch,000h,010h,000h		;'j'
				DB	018h,010h,010h,010h,014h,008h,000h,002h		;'k'
				DB	002h,00Ah,006h,00Ah,012h,000h,000h,008h		;'l'
				DB	008h,008h,008h,008h,018h,000h,000h,000h		;'m'
				DB	014h,02Ah,02Ah,02Ah,02Ah,000h,000h,000h		;'n'
				DB	00Eh,012h,012h,012h,012h,000h,000h,000h		;'o'
				DB	00Ch,012h,012h,012h,00Ch,000h,000h,000h		;'p'
				DB	00Eh,012h,012h,00Eh,002h,002h,000h,000h		;'q'
				DB	01Ch,012h,012h,01Ch,010h,010h,000h,000h		;'r'
				DB	00Ah,016h,002h,002h,002h,000h,000h,000h		;'s'
				DB	01Ch,002h,00Ch,010h,00Eh,000h,000h,008h		;'t'
				DB	008h,01Ch,008h,008h,018h,000h,000h,000h		;'u'
				DB	012h,012h,012h,012h,01Ch,000h,000h,000h		;'v'
				DB	012h,012h,012h,004h,008h,000h,000h,000h		;'w'
				DB	022h,022h,02Ah,02Ah,014h,000h,000h,000h		;'x'
				DB	022h,014h,008h,014h,022h,000h,000h,000h		;'y'
				DB	012h,012h,012h,01Ch,010h,00Ch,000h,000h		;'z'
				DB	01Eh,008h,004h,002h,01Eh,000h,010h,008h		;'{'
				DB	008h,004h,008h,008h,010h,000h,008h,008h		;'|'
				DB	008h,000h,008h,008h,008h,000h,004h,008h		;'}'
				DB	008h,010h,008h,008h,004h,000h,000h,000h		;'~'
				DB	004h,02Ah,010h,000h,000h,000h,000h,000h		;'⌂'
				DB	000h,01Ch,014h,01Ch,000h,000h,007h,007h		;80h
				DB	007h,007h,007h,007h,007h,007h,038h,038h		;81h
				DB	038h,038h,038h,038h,038h,038h,000h,000h		;82h
				DB	000h,000h,000h,03Fh,03Fh,03Fh,03Fh,03Fh		;83h
				DB	03Fh,000h,000h,000h,000h,000h,00Ch,00Ch		;84h
				DB	00Ch,00Ch,00Ch,00Ch,00Ch,00Ch,000h,000h		;85h
				DB	000h,03Fh,03Fh,000h,000h,000h,030h,038h		;86h
				DB	03Ch,01Eh,00Fh,007h,003h,001h,003h,007h		;87h
				DB	00Fh,01Eh,03Ch,038h,030h,020h,00Ch,00Ch		;88h
				DB	00Ch,03Fh,03Fh,00Ch,00Ch,00Ch,03Fh,03Fh		;89h
				DB	03Fh,038h,038h,038h,038h,038h,03Fh,03Fh		;8Ah
				DB	03Fh,007h,007h,007h,007h,007h,03Fh,03Fh		;8Bh
				DB	03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,00Ch,00Ch		;8Ch
				DB	00Ch,00Ch,00Ch,03Fh,03Fh,03Fh,03Fh,03Fh		;8Dh
				DB	03Fh,00Ch,00Ch,00Ch,00Ch,00Ch,004h,00Eh		;8Eh
				DB	01Fh,01Fh,01Fh,004h,004h,000h,000h,00Ah		;8Fh
				DB	01Fh,01Fh,01Fh,00Eh,004h,000h,012h,03Fh		;90h
				DB	02Dh,03Fh,021h,03Fh,012h,012h,004h,00Eh		;91h
				DB	00Eh,01Fh,00Eh,00Eh,004h,000h,00Eh,004h		;92h
				DB	015h,01Fh,015h,004h,004h,000h,007h,007h		;93h
				DB	007h,007h,007h,03Fh,03Fh,03Fh,038h,038h		;94h
				DB	038h,038h,038h,03Fh,03Fh,03Fh,015h,02Ah		;95h
				DB	015h,02Ah,015h,02Ah,015h,02Ah

4617   8A6E 3A B8 C1	L0156:	LD	A,(0C1B8h)		;1. znak nazvu souboru
4618   8A71 FE 2A		CP	02Ah			;test na ochranu souboru
4619   8A73 C3 3F 83		JP	L0187

4620   8A76 21 5C 83	L0254:	LD	HL,0835Ch		;text '++ FILE ERROR ++'
4621   8A79 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
4622   8A7C C9			RET

			;******************************************************************************
			;XCUR - vykresleni/smazani kurzoru
			; vstup: CURSOR 0C03Eh= pozice kurzoru
			;******************************************************************************
4623   8A7D 2A 3E C0	L8A7D:	LD	HL,(0C03Eh)		;adresa kurzoru na obrazovce
4624   8A80 01 C0 FF	L0206:	LD	BC,0FFC0h
4625   8A83 09			ADD	HL,BC
4626   8A84 7E			LD	A,(HL)
4627   8A85 EE 3E		XOR	03Eh
4628   8A87 77			LD	(HL),A
4629   8A88 C9			RET

			;******************************************************************************
			;PRTTEXT - pipnuti a tisk hlaseni
			; vstup: MESS 0C074h= adr. textu hlaseni ukonceneho 00Dh
			; DIAL= pozice dial. radku na obrazovce
			; vyst.: provede vypis, vola BEEP /08A8Ch nezavola BEEP/
			;******************************************************************************
4630   8A89 CD A3 88	L8A89:	CALL	L0037			;standardni pipnuti
4631   8A8C C3 36 8B		JP	L0188			;zobrazeni hlaseni

			;******************************************************************************
			;obsluha prikazu MONITORu SUB
			;******************************************************************************
4632   8A8F 21 91 82	L8A8F:	LD	HL,08291h		;text '** ERROR IN DATA **'
4633   8A92 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
4634   8A95 CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu do DE
4635   8A98 CD 24 8F	L0184:	CALL	L0112			;ignorovani mezer v editacnim radku, v Acc je znak
4636   8A9B FE 0D		CP	00Dh			;test na EOL
4637   8A9D CA A3 83		JP	Z,L0189			;je - vypis noveh editacniho radku se 'SUB '
4638   8AA0 FE 27		CP	027h			;test a apostrof
4639   8AA2 CA B0 8A		JP	Z,L0190			;je, vklada se ASCII znak
4640   8AA5 CD F7 80		CALL	L0025			;PARIN - konverze hex na 8 bitu
4641   8AA8 DA 49 80		JP	C,L0032			;navrat do MONITORu, vypis chyboveho hlaseni
4642   8AAB 12			LD	(DE),A			;uloz prevedeny hex do pameti
4643   8AAC 13			INC	DE			;dalsi pametove misto
4644   8AAD C3 98 8A		JP	L0184			;pokracuj dalsim hex znakem z editacniho radku
4645   8AB0 23		L0190:	INC	HL			;preskoc apostrof veditacnim radku
4646   8AB1 7E		L0191:	LD	A,(HL)			;cti znak z editacniho radku
4647   8AB2 FE 0D		CP	00Dh			;test na EOL
4648   8AB4 23			INC	HL			;dalsi adresa v editacnim radku
4649   8AB5 CA A3 83		JP	Z,L0189			;je - vypis noveho editacniho radku se 'SUB '
4650   8AB8 FE 27		CP	027h			;test na apostrof
4651   8ABA CA 98 8A		JP	Z,L0184			;je, konec zadavani ASCII znaku
4652   8ABD 12			LD	(DE),A			;jinak uloz ASCII znak do pameti
4653   8ABE 13			INC	DE			;dalsi pametove misto
4654   8ABF C3 B1 8A		JP	L0191			;pokracuj dalsim ASCII znakem zeditacniho buferu

			;******************************************************************************
			;pridani klice do tabulky
			;******************************************************************************
4655   8AC2 CD A3 88	L0148:	CALL	L0037			;standardni pipnuti
4656   8AC5 CD 5E 81		CALL	L0027			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
4657   8AC8 45		L0212:	LD	B,L
4658   8AC9 21 7C 83		LD	HL,0837Ch		;text '++ MEMORY OVERFLOV ++'
4659   8ACC 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
4660   8ACF 2A 7C C1		LD	HL,(0C17Ch)		;adresa klicu
4661   8AD2 2B		L0193:	DEC	HL
4662   8AD3 7E			LD	A,(HL)			;znak z klicu
4663   8AD4 B7			OR	A			;je znak prazdny?
4664   8AD5 CA F6 8A		JP	Z,L0192			;je, skoc
4665   8AD8 B9			CP	C			;porovnej se stisknutou klavesou
4666   8AD9 C2 D2 8A		JP	NZ,L0193		;klavesa se neshoduje, dalsi znak
4667   8ADC	54		LD	D,H			;do DE aktualni adresa v klicich
4668   8ADD	5D		LD	E,L
4669   8ADE 2B		L0195:	DEC	HL			;
4670   8ADF 7E			LD	A,(HL)			;znak z klicu
4671   8AE0 B7			OR	A			;je znak prazdny?
4672   8AE1 CA F7 8A		JP	Z,L0194			;je, skoc
4673   8AE4 F2 DE 8A		JP	P,L0195			;je znak mensi nez 080h
4674   8AE7 FE E0		CP	0E0h			;test na konec klice
4675   8AE9 D2 DE 8A		JP	NC,L0195		;jeste neni konec, dalsi znak z klicu
4676   8AEC 7E		L0196:	LD	A,(HL)			;
4677   8AED 12			LD	(DE),A
4678   8AEE 2B			DEC	HL
4679   8AEF 1B			DEC	DE
4680   8AF0 B7			OR	A
4681   8AF1 C2 EC 8A		JP	NZ,L0196
4682   8AF4 13			INC	DE
4683   8AF5 EB			EX	DE,HL
4684   8AF6 EB		L0192:	EX	DE,HL
4685   8AF7 2A 7E C1	L0194:	LD	HL,(0C17Eh)		;radoby hranice pameti pro klice
4686   8AFA 7B			LD	A,E			;kontrola prekroceni hranice klicu
4687   8AFB 95			SUB	L
4688   8AFC 7A			LD	A,D
4689   8AFD 9C			SBC	A,H
4690   8AFE DA 32 8B		JP	C,L0197			;vypis chyboveho hlaseni ++ MEMORY OVERFLOV ++
4691   8B01 2A 7C C1		LD	HL,(0C17Ch)		;adresa klicu
4692   8B04 EB			EX	DE,HL
4693   8B05 05			DEC	B
4694   8B06 FA 14 8B		JP	M,L0198
4695   8B09 04			INC	B
4696   8B0A 71			LD	(HL),C
4697   8B0B 2B			DEC	HL
4698   8B0C 1A		L0199:	LD	A,(DE)
4699   8B0D 77			LD	(HL),A
4700   8B0E 2B			DEC	HL
4701   8B0F 13			INC	DE
4702   8B10 05			DEC	B
4703   8B11 C2 0C 8B		JP	NZ,L0199
4704   8B14 36 00	L0198:	LD	(HL),000h
4705   8B16 21 35 C1	L0225:	LD	HL,0C135h		;priznak WRK
4706   8B19 36 00		LD	(HL),000h		;nuluj priznak WRK
4707   8B1B C9			RET

			;******************************************************************************
			;OCHRAN - ochrana proti prohlizeni pameti
			; vstup: OCHR 0C1F1h= kod ochrany, 02Ah= chraneno
			; vyst.: je-li pamet chranena, smaze celou pamet a provede
			; reset systemu. Tato sluzba je volana po resetu, takze
			; jiz spusteny chraneny program je resetem vymazan
			;******************************************************************************
4708   8B1C 21 00 00	L0002:	LD	HL,00000h
4709   8B1F E5		L0200:	PUSH	HL			;vynuluje postupne celou RAM
4710   8B20 3A F1 C1		LD	A,(0C1F1h)		;pokus o ochranu souboru, * => chraneno
4711   8B23 FE 2A		CP	02Ah
4712   8B25 CA 1F 8B		JP	Z,L0200			;soubor chranen - skoc
4713   8B28 31 00 80		LD	SP,08000h		;znovunastaveni SP
4714   8B2B 11 31 82		LD	DE,V8231		;inicializacni data
4715   8B2E C3 0D 80		JP	L0201			;inicializace systemu

			;******************************************************************************
			;ERROR - vypis chyboveho hlaseni
			; vstup: MESS 0C074h= adr. textu
			;******************************************************************************
4716   8B31 E5		L0009:	PUSH	HL
4717   8B32 CD A3 88	L0197:	CALL	L0037			;standardni pipnuti
4718   8B35 E1			POP	HL			;ukazatel na text '** OS READY **'
4719   8B36 2A 74 C0	L0188:	LD	HL,(0C074h)		;zacatek textu hlaseni
4720   8B39 EB		L0041:	EX	DE,HL
4721   8B3A 2A 3A C1		LD	HL,(0C13Ah)		;adr. C-D bufferu
4722   8B3D 06 30		LD	B,030h			;sirka radku - 48 znaku
4723   8B3F EB			EX	DE,HL
4724   8B40 CD C5 81		CALL	L0039			;TEXTSP - prenos textu z (HL) do (DE) s doplnenim mezer na delku B
4725   8B43 C3 9B 88		JP	L0202			;obsluha klavesy C-D

			;******************************************************************************
			;ENDLN - vyhledani posledniho znaku v editacnim bufferu
			; vstup: DLZRAD 0C034h= konec textu
			; vyst.: HL= adresa posledniho platneho znaku
			;******************************************************************************
4726   8B46 2A 34 C0	L0146:	LD	HL,(0C034h)		;konec bufferu dialogoveho radku
4727   8B49 3E 20	L0204:	LD	A,020h			;porovnava se mezera
4728   8B4B BE			CP	(HL)			;porovnej s buferem
4729   8B4C C2 53 8B		JP	NZ,L0203		;není mezera, skoc
4730   8B4F 2D			DEC	L			;posun v buferu
4731   8B50 C2 49 8B		JP	NZ,L0204		;nejsem na zacatku, opakuj
4732   8B53 7C		L0203:	LD	A,H			;schovej si H
4733   8B54 26 00		LD	H,000h			;nuluj H
4734   8B56 22 3C C1		LD	(0C13Ch),HL		;LSTR - nastav konec textu v buferu
4735   8B59 67			LD	H,A			;obnov H
4736   8B5A C9			RET				;navrat

			;******************************************************************************
			;pokracovani ENTER
			;******************************************************************************
4737   8B5B 22 7A C0	L0214:	LD	(0C07Ah),HL		;adresa zasobniku pro navrat z ENTER
4738   8B5E 2A 70 C0		LD	HL,(0C070h)		;adresa vrcholu zasobniku
4739   8B61 F9			LD	SP,HL
4740   8B62 2A 32 C0	L0208:	LD	HL,(0C032h)		;zacatek vypisu dial. radku na obrazovce
4741   8B65 CD 61 81		CALL	L0205			;vypocet pozice kurzoru
4742   8B68 22 75 C1		LD	(0C175h),HL		;DCUROLD
4743   8B6B CD 80 8A		CALL	L0206			;vykresleni/smazani kurzoru
4744   8B6E CD A1 84		CALL	L0010			;INKLAV - nacteni znaku z klavesnice s cekanim na stisk
4745   8B71 2A 75 C1		LD	HL,(0C175h)		;DCUROLD
4746   8B74 CD 80 8A		CALL	L0206			;vykresleni/smazani kurzoru
4747   8B77 CD 00 88		CALL	L0207			;EDIT - provedeni zmeny v editacnim radku
4748   8B7A 3A 34 C1		LD	A,(0C134h)		;znak nacteny z klavesnice z INKLAV
4749   8B7D FE 0D		CP	00Dh			;kontrola na EOL
4750   8B7F C2 62 8B		JP	NZ,L0208		;nebylo EOL, opakuj smycku
4751   8B82 CD 13 81		CALL	L0008			;obsluha klavesy CLL - vymaz celeho radku
4752   8B85 CD 55 88		CALL	L0012			;WRLINE - vypis editacniho bufferu do dialogoveho radku
4753   8B88 2A 7A C0		LD	HL,(0C07Ah)		;adresa zasobniku pro navrat z ENTER
4754   8B8B F9			LD	SP,HL
4755   8B8C 2A 76 C0		LD	HL,(0C076h)		;navratova adresa pro ENTER
4756   8B8F E9			JP	(HL)

			;******************************************************************************
			;Obsluha klavesy ENDL
			;******************************************************************************
4757   8B90 CD 46 8B		CALL	L0146			;ENDLN - vyhledani posledniho znaku v editacnim bufferu
4758   8B93 3A 34 C0		LD	A,(0C034h)		;konec bufferu dial. radku
4759   8B96 BD			CP	L
4760   8B97 CA 9B 8B		JP	Z,L0209
4761   8B9A 2C			INC	L
4762   8B9B 3A FE C0	L0209:	LD	A,(0C0FEh)		;pocet znaku pro vypis edit bufferu
4763   8B9E 3D			DEC	A
4764   8B9F BD			CP	L
4765   8BA0 7D			LD	A,L
4766   8BA1 21 38 C0		LD	HL,0C038h		;1. vypisovany znak z bufferu na obrazovku
4767   8BA4 D2 B0 8B		JP	NC,L0210
4768   8BA7 4F			LD	C,A
4769   8BA8 3A FF C0		LD	A,(0C0FFh)		;DLZP
4770   8BAB 47			LD	B,A
4771   8BAC 77			LD	(HL),A
4772   8BAD 79			LD	A,C
4773   8BAE 90			SUB	B
4774   8BAF 21 36 00		DB	021h			;LD	HL,03600h
			L0210:	LD	(HL),000h
4775   8BB2 32 36 C0		LD	(0C036h),A		;pozice kurzoru v bufferu
4776   8BB5 C9			RET

			;******************************************************************************
			;Obsluha klavesy EOL
			;******************************************************************************
4777   8BB6 CD 46 8B	L0281:	CALL	L0146			;ENDLN - vyhledani posledniho znaku v editacnim bufferu
4778   8BB9 E5			PUSH	HL
4779   8BBA 45			LD	B,L
4780   8BBB 2A 30 C0		LD	HL,(0C030h)		;zacatek bufferu dialogoveho radku
4781   8BBE EB			EX	DE,HL
4782   8BBF 2A 78 C0		LD	HL,(0C078h)		;adr. ulozeni textu po EOL v ENTER
4783   8BC2 3A 37 C1		LD	A,(0C137h)		;priznak PTL
4784   8BC5 4F			LD	C,A
4785   8BC6 1A		L0211:	LD	A,(DE)
4786   8BC7 77			LD	(HL),A
4787   8BC8 23			INC	HL
4788   8BC9 13			INC	DE
4789   8BCA 0C			INC	C
4790   8BCB C4 00 85		CALL	NZ,L0030		;PRTOUT - vypis znaku do obrazovky
4791   8BCE 0D			DEC	C
4792   8BCF 05			DEC	B
4793   8BD0 F2 C6 8B		JP	P,L0211
4794   8BD3 36 0D		LD	(HL),00Dh
4795   8BD5 0C			INC	C
4796   8BD6 C4 FE 84		CALL	NZ,L0049		;odradkovani
4797   8BD9 E1			POP	HL
4798   8BDA 0E 87		LD	C,087h
4799   8BDC 23			INC	HL
4800   8BDD C3 C8 8A		JP	L0212

			;******************************************************************************
			;pokracovani DELT - posunuti textu v editacnim buferu o 1 znak doleva, doplneni
			;mezerou na konci textu
			;******************************************************************************
4801   8BE0 1A		L0213:	LD	A,(DE)			;cti znak z buferu
4802   8BE1 77			LD	(HL),A			;uloz znak do buferu
4803   8BE2 79			LD	A,C			;test na nulovost BC
4804   8BE3 BB			CP	E
4805   8BE4 23			INC	HL			;dalsi pozice v buferu
4806   8BE5 13			INC	DE
4807   8BE6 C2 E0 8B		JP	NZ,L0213		;opakuj pro cely text 
4808   8BE9 36 20	L0237:	LD	(HL),020h		;na uvolnenou pozici dej mezeru
4809   8BEB C9			RET				;navrat

4810   8BEC 00		V8BEC:	DB	000h,000h

			;******************************************************************************
			;ENTER - vstup radky s editaci
			; vstup: RETCLL 0C076h= navrat po EOL
			; ODLOZ 0C078h= adr. ulozeni textu po EOL
			; RETSP 0C07Ah= adr. odlozeni zasobniku
			; vyst.: vola INKLAV 084A1h, zajistuje spravnou korespondenci
			; mezi uzivatelskym programem a MONITORem. Umoznuje
			; odlozeni vrcholu zasobniku, vlastni nastavi na 07FFFh
			;******************************************************************************
4812   8BEE CD 55 88	L0013:	CALL	L0012			;WRLINE - vypis editacniho bufferu do dialogoveho radku
4813   8BF1 E1		L0351:	POP	HL
4814   8BF2 22 76 C0		LD	(0C076h),HL		;navratova adresa pro ENTER
4815   8BF5 21 00 00		LD	HL,00000h
4816   8BF8 39			ADD	HL,SP
4817   8BF9 C3 5B 8B		JP	L0214

4818   8BFC 00		V8BFC:	DB	000h,000h,000h,000h

4822   8C00 C3 A4 8F	L0886:	JP	TRANSF

			;******************************************************************************
			;SCAN - letmy test klavesnice
			; vyst.: Z= nic neni stisknuto, A=000h
			; NZ, A= kod stisknute klavesy
			;******************************************************************************
4823   8C03 C5		L0099:	PUSH	BC
4824   8C04 06 07		LD	B,007h			;testuje se 7 radku klavesnice
4825   8C06 0E 7F		LD	C,07Fh			;maska radku klavesnice
4826   8C08 79		L0217:	LD	A,C			;maska klavesnice
4827   8C09 07			RLCA				;rotace masky klavesnice
4828   8C0A 4F			LD	C,A			;schovej pro dalsi pruchod
4829   8C0B D3 F4		OUT	(0F4h),A		;8255 PA - zapis radek klavesnice
4830   8C0D DB F5		IN	A,(0F5h)		;8255 PB - cti sloupec klavesnice
4831   8C0F 2F			CPL				;inverze - zustane nastaven stisknuty sloupec
4832   8C10 B7			OR	A			;je neco stisknuto?
4833   8C11 C2 C3 84		JP	NZ,L0216		;je, skoc - prevod scan kodu na kod klavesy
4834   8C14 05			DEC	B			;pocitadlo radku klavesnice
4835   8C15 F2 08 8C		JP	P,L0217			;opakuj pro vsechny radky
4836   8C18 C1			POP	BC			;obnov PC
4837   8C19 AF			XOR	A			;nuluj A - nasavi se Z
4838   8C1A C9			RET

			;******************************************************************************
			;Casova prodleva pro INKLAV
			;******************************************************************************
; tato rutina nie je vo verzii LAN vyuzita !
4839   8C1B C5		L0098:	PUSH	BC			;C=032h
4840   8C1C 47			LD	B,A			;A=003h
4841   8C1D 0B		L0218:	DEC	BC			;BC=0332h
4842   8C1E 79			LD	A,C
4843   8C1F B0			OR	B
4844   8C20 C2 1D 8C		JP	NZ,L0218
4845   8C23 C1			POP	BC
4846   8C24 C9			RET

4847   8C25 36 06	L0102:	LD	(HL),006h		;(0C0BDh)
4848   8C27 F5		L0101:	PUSH	AF
4849   8C28 3A BF C0		LD	A,(0C0BFh)		;priznak pipnuti pri stisku klavesy
4850   8C2B B7			OR	A			;je puknuti povoleno?
4851   8C2C CA 35 8C		JP	Z,L0219			;neni, skoc
4852   8C2F 21 F4 80		LD	HL,V80F4		;data pro puknuti klavesy
4853   8C32 CD A6 88		CALL	L88A6			;BELL - generuje tony podle tabulky
4854   8C35 F1		L0219:	POP	AF
4855   8C36 C3 F4 84		JP	L0220			;obnoveni registru, ulozeni kodu prectene klavesy

4856   8C39 3A 7C C0	L0244:	LD	A,(0C07Ch)		;konstanta rychlosti cteni z magnetofonu
4857   8C3C 17			RLA
4858   8C3D C3 62 8D		JP	L0221

4859   8C40 C3 3B 80		JP	L803B			;MON

			;******************************************************************************
			;DOKEY - provedeni zmeny v editacnim bufferu
			; vstup: ASCII 0C134h ridici nebo graficky znak
			; vyst.: zmeneny text v bufferu
			;******************************************************************************
4860   8C43 3A 34 C1	L0011:	LD	A,(0C134h)		;znak nacteny z klavesnice z INKLAV
4861   8C46 47			LD	B,A
4862   8C47 FE E0		CP	0E0h
4863   8C49 D2 94 81		JP	NC,L0223
4864   8C4C FE D0		CP	0D0h			;0D0h..0DBh - vyvolani/ulozeni klice
4865   8C4E D2 27 88		JP	NC,L0224		;obsluha vyvolani/ulozeni klicu K0..K11
4866   8C51 FE 20		CP	020h
4867   8C53 CD 16 8B		CALL	L0225
4868   8C56 D2 94 81		JP	NC,L0223
4869   8C59 2A 32 C1		LD	HL,(0C132h)		;adresa tabulky adres podprogramu ridicich klaves
4870   8C5C 23		L0226:	INC	HL
4871   8C5D 23			INC	HL
4872   8C5E 7E			LD	A,(HL)
4873   8C5F A7			AND	A
4874   8C60 C8			RET	Z
4875   8C61 23			INC	HL
4876   8C62 B8			CP	B
4877   8C63 C2 5C 8C		JP	NZ,L0226
4878   8C66 46		L0113:	LD	B,(HL)			;LOW byte obsluzne adresy
4879   8C67 23			INC	HL			;dalsi byte v tabulce
4880   8C68 66			LD	H,(HL)			;HIGH byte obsluzne adresy
4881   8C69 68			LD	L,B			;v HL je adresa obsluhy prikazu
4882   8C6A E9			JP	(HL)			;skoc na obsluhu prikazu

			;******************************************************************************
			;I/0 INI - nastaveni interf. desky
			;******************************************************************************
4883   8C6B 3E 8A	L0005:	LD	A,08Ah			;PA OUT, PB IN, PCL OUT, PCH IN
4884   8C6D D3 F7		OUT	(0F7h),A		;CW PIO 8255
4885   8C6F C3 A7 85		JP	L0109			;smazani obrazovky

4886   8C72 00		V8C72:	DB	000h,000h

			;******************************************************************************
			;STOP - test klavesy STOP
			; vyst.: Z, A=03 STOP stisknuto
			; NZ, A=40 STOP nestisknuto
			;******************************************************************************
4888   8C74 DB F6	L0050:	IN	A,(0F6h)		;cti PC 8255
4889   8C76 E6 10		AND	010h			;odmaskuj jen klavesu STOP
4890   8C78 C0			RET	NZ			;nestisknuto, navrat
4891   8C79 3E 03		LD	A,003h			;priznak stisku STOP
4892   8C7B C9			RET				;navrat

4893   8C7C 00		V8C7C:	DB	000h

			;******************************************************************************
			;POINT - vykresleni bodu v danem grafickem modu
			; vstup: X1 0C170h, Y1 0C172h = souradnice bodu
			; MODIFY 0C1FAh= mod zobrazeni /AB negace, AF zhaseni,
			; B0 rozvecovani/, COLOR 0C03Ah= atribut /barva/
			; vyst.: vykresli bod vypocteny ze zadanych souradnic vzhledem 
			; ke strojove nule 0C000h
			; znici: PSW
			;******************************************************************************
4894   8C7D C5		L8C7D:	PUSH	BC			;uklid registru
4895   8C7E D5			PUSH	DE
4896   8C7F E5			PUSH	HL
4897   8C80 21 75 85		LD	HL,08575h		;adresa 3xPOP + RET
4898   8C83 E5			PUSH	HL			;dej na vrchol zasobniku
4899   8C84 2A 71 C1	L0228:	LD	HL,(0C171h)		;souradnice X pocatecniho bodu
4900   8C87 3A 70 C1		LD	A,(0C170h)		;souradnice X pocatecniho bodu
4901   8C8A 6F			LD	L,A
4902   8C8B E5			PUSH	HL
4903   8C8C CD 94 8C		CALL	L0118			;POSPOINT - vypocet bodu na obrazovce + bitova maska vykresleni
4904   8C8F CD F4 C1		CALL	L0227			;vykresleni bodu danym stylem - negace/zhasnuti/rozsviceni
4905   8C92 D1			POP	DE
4906   8C93 C9			RET

			;******************************************************************************
			;POSPOINT - vypocet bodu na obrazovce + bitova maska vykresleni
			; vstup: L= souradnice X, H= souradnice Y
			; vyst.: HL= adresa byte v displeji
			; B: bitova maska (1,2,4,8,10,20,40,80)
			;******************************************************************************
4907   8C94 E5		L0118:	PUSH	HL			;schovej si vstupni souradnice
4908   8C95 3A 3A C0		LD	A,(0C03Ah)		;atribut zobrazeni
4909   8C98 E6 C0		AND	0C0h			;ponech jen atributy zobrazeni
4910   8C9A 32 F8 C1		LD	(0C1F8h),A		;PLOTCOL
4911   8C9D 26 00		LD	H,000h			;nuluj Y souradnici
4912   8C9F 4D			LD	C,L			;X zkopiruj do C
4913   8CA0 44			LD	B,H			;nuluj B
4914   8CA1 23			INC	HL			;zvetsi X
4915   8CA2 54			LD	D,H			;zkopiruj do DE
4916   8CA3 5D			LD	E,L
4917   8CA4 29			ADD	HL,HL			;*2	vynasobenim souradnice X
4918   8CA5 29			ADD	HL,HL			;*4	85-ti se v registru H
4919   8CA6 19			ADD	HL,DE			;*5	ziska vysledek X DIV 3
4920   8CA7 29			ADD	HL,HL			;*10	(255/85=3)
4921   8CA8 29			ADD	HL,HL			;*20
4922   8CA9 19			ADD	HL,DE			;*21
4923   8CAA 29			ADD	HL,HL			;*42
4924   8CAB 29			ADD	HL,HL			;*84
4925   8CAC 19			ADD	HL,DE			;*85
4926   8CAD 3E FE		LD	A,0FEh			;odmaskuje se nejmene vyznamny bit
4927   8CAF A4			AND	H			;v A je X DIV 3
4928   8CB0 0F			RRCA				;deleni 2-mi - v A je X DIV 6
4929   8CB1 5F			LD	E,A			;zkopiruj do E
4930   8CB2 7B			LD	A,E			;asi nejaky neodstraneny zbytek kodu
4931   8CB3 87			ADD	A,A			;*2
4932   8CB4 83			ADD	A,E			;*3
4933   8CB5 87			ADD	A,A			;*6 - zpetny prevod byte na pixely
4934   8CB6 91			SUB	C			;puvodni souradnice X
4935   8CB7 2F			CPL				;dvojkovy doplnek
4936   8CB8 3C			INC	A			;v A je X MOD 6
4937   8CB9 4F			LD	C,A			;v BC je X MOD 6
4938   8CBA 16 C0		LD	D,0C0h			;pocatek VRAM - 0C000h
4939   8CBC 1C			INC	E			;posun grafiky o 12 bodu doprava
4940   8CBD 1C			INC	E
4941   8CBE 21 D7 80		LD	HL,V80D7		;tabulka prevodu poradi - bitova maska
4942   8CC1 09			ADD	HL,BC			;pripocti X MOD 6
4943   8CC2 46			LD	B,(HL)			;nastavi pozici vypocteneho bitu v byte
4944   8CC3 E1			POP	HL			;obnov si vstupni souradnice
4945   8CC4 6C			LD	L,H			;Y do L
4946   8CC5 26 00		LD	H,000h			;vyssi byte nuluj
4947   8CC7 29			ADD	HL,HL			;*2
4948   8CC8 29			ADD	HL,HL			;*4
4949   8CC9 29			ADD	HL,HL			;*8
4950   8CCA 29			ADD	HL,HL			;*16
4951   8CCB 29			ADD	HL,HL			;*32
4952   8CCC 29			ADD	HL,HL			;*64 - vzdalenost mikroradku v RAM
4953   8CCD 19			ADD	HL,DE			;pricteni vypoctene adresy X a pocatku VRAM
4954   8CCE C9			RET				;navrat

4955   8CCF 00		V8CCF:	DB	000h

				;******************************************************************************
				;Lineární interpolátor
				; vstup: X1,Y1 = souřadnice počátečního bodu
				;	 X2,Y2 = souřadnice koncového bodu
				;******************************************************************************
32094956   8CD0 CD 84 8C    L0788:	CALL	L0228			;cast POINT - rozsviceni pocatecniho bodu
4957   8CD3 2A 73 C1		LD	HL,(0C173h)		;souradnice X koncoveho bodu
4958   8CD6 7D			LD	A,L
4959   8CD7 32 70 C1		LD	(0C170h),A		;souradnice X pocatecniho bodu
4960   8CDA 7C			LD	A,H
4961   8CDB 32 72 C1		LD	(0C172h),A		;souradnice Y pocatecniho bodu
4962   8CDE 7D			LD	A,L			;porovnani pocatku a konce u X
4963   8CDF 93			SUB	E
4964   8CE0 D2 E6 8C		JP	NC,L0229
4965   8CE3 7B			LD	A,E			;uprava, aby hodnota X mohla rust
4966   8CE4 95			SUB	L
4967   8CE5 EB			EX	DE,HL			;prohozeni pocatecniho a koncoveho bodu
4968   8CE6 47		L0229:	LD	B,A			;rozhodnuti, zda Y bude pribyvat nebo ubyvat
4969   8CE7 7C			LD	A,H
4970   8CE8 92			SUB	D
4971   8CE9 11 C0 FF		LD	DE,0FFC0h		;DE=-40h
4972   8CEC D2 F4 8C		JP	NC,L0230
4973   8CEF 11 40 00		LD	DE,00040h		;DE=40h
4974   8CF2 2F			CPL
4975   8CF3 3C			INC	A
4976   8CF4 4F		L0230:	LD	C,A
4977   8CF5 EB			EX	DE,HL
4978   8CF6 22 3E C1		LD	(0C13Eh),HL		;misto pro odkladani ukazatele zasobniku
4979   8CF9 EB			EX	DE,HL
4980   8CFA 50			LD	D,B
4981   8CFB 5F			LD	E,A
4982   8CFC 1C			INC	E
4983   8CFD D5			PUSH	DE
4984   8CFE C5			PUSH	BC
4985   8CFF CD 94 8C		CALL	L0118			;POSPOINT - vypocet bodu na obrazovce + bitova maska vykresleni
4986   8D02 50			LD	D,B
4987   8D03 C1			POP	BC
4988   8D04 58			LD	E,B
4989   8D05 42			LD	B,D
4990   8D06 7B			LD	A,E
4991   8D07 B9			CP	C
4992   8D08 D2 15 8D		JP	NC,L0231
4993   8D0B B7			OR	A
4994   8D0C 1F			RRA
4995   8D0D 91			SUB	C
4996   8D0E 5F			LD	E,A
4997   8D0F 1D			DEC	E
4998   8D10 7B			LD	A,E
4999   8D11 D1			POP	DE
5000   8D12 C3 42 8D		JP	L0232
5001   8D15 79		L0231:	LD	A,C
5002   8D16 1F			RRA
5003   8D17 93			SUB	E
5004   8D18 2F			CPL
5005   8D19 5F			LD	E,A
5006   8D1A 1C			INC	E
5007   8D1B 06 00		LD	B,000h
5008   8D1D 78		L0234:	LD	A,B
5009   8D1E 82			ADD	A,D
5010   8D1F 47			LD	B,A
5011   8D20 7A		L0236:	LD	A,D
5012   8D21 0F			RRCA
5013   8D22 57			LD	D,A
5014   8D23 D2 2E 8D		JP	NC,L0233
5015   8D26 CD F4 C1		CALL	L0227			;vykresleni bodu danym stylem - negace/zhasnuti/rozsviceni
5016   8D29 2B			DEC	HL
5017   8D2A 16 20		LD	D,020h
5018   8D2C 06 00		LD	B,000h
5019   8D2E 37		L0233:	SCF
5020   8D2F 7B			LD	A,E
5021   8D30 99			SBC	A,C
5022   8D31 5F			LD	E,A
5023   8D32 D2 1D 8D		JP	NC,L0234
5024   8D35 CD F4 C1	L0235:	CALL	L0227			;vykresleni bodu danym stylem - negace/zhasnuti/rozsviceni
5025   8D38 42			LD	B,D
5026   8D39 7B			LD	A,E
5027   8D3A EB			EX	DE,HL
5028   8D3B 2A 3E C1		LD	HL,(0C13Eh)		;misto pro odkladani ukazatele zasobniku
5029   8D3E 19			ADD	HL,DE
5030   8D3F D1			POP	DE
5031   8D40 1D			DEC	E
5032   8D41 C8			RET	Z
5033   8D42 D5		L0232:	PUSH	DE
5034   8D43 37			SCF
5035   8D44 8A			ADC	A,D
5036   8D45 5F			LD	E,A
5037   8D46 50			LD	D,B
5038   8D47 D2 35 8D		JP	NC,L0235
5039   8D4A C3 20 8D		JP	L0236

			;******************************************************************************
			;Obsluha klavesy DELT - zruseni znaku na pozici kurzoru
			;******************************************************************************
5040   8D4D CD 46 8B	L8D4D:	CALL	L0146			;ENDLN - vyhledani posledniho znaku v editacnim bufferu
5041   8D50 4D			LD	C,L
5042   8D51 CD 5E 81		CALL	L0027			;CURPOS - vypocet adresy aktualniho znaku v edit. bufferu
5043   8D54 54			LD	D,H
5044   8D55 5D			LD	E,L
5045   8D56 13			INC	DE
5046   8D57 79			LD	A,C
5047   8D58 BB			CP	E
5048   8D59 DA E9 8B		JP	C,L0237
5049   8D5C C3 E0 8B		JP	L0213

			;******************************************************************************
			;Casova prodleva cteni z magnetofonu
			;******************************************************************************
5050   8D5F 3A 7C C0	L0243:	LD	A,(0C07Ch)		;konstanta rychlosti cteni z magnetofonu
5051   8D62 3D		L0221:	DEC	A			;sniz delku cekani
5052   8D63 C2 62 8D		JP	NZ,L0221		;opakuj, dokud neni 0
5053   8D66 DB F6		IN	A,(0F6h)		;cti data z magnetofonu
5054   8D68 17			RLA				;precteny bit do CY
5055   8D69 C9			RET				;navrat

5056   8D6A 00		V8D6A:	DB	000h,000h

			;******************************************************************************
			;TAPEOUT - zapis bloku dat na magnetofon.
			; vstup: HL= zacatek dat
			; DE= pocet byte-1
			; vyst.: zapsany blok dat
			;******************************************************************************
5058   8D6C 13		L0279:	INC	DE			;uprav delku zapisovanych dat
5059   8D6D 06 00		LD	B,000h			;nuluj CRC
5060   8D6F 7E		L0239:	LD	A,(HL)			;precti byte k zapsani
5061   8D70 CD 7E 8D		CALL	L0238			;zapis 1 byte na magnetofon
5062   8D73 7E			LD	A,(HL)			;precti byte k zapsani
5063   8D74 80			ADD	A,B			;pricti k CRC
5064   8D75 47			LD	B,A			;vrat CRC zpatky
5065   8D76 23			INC	HL			;dalsi byte k zapisu
5066   8D77 1B			DEC	DE			;pocitadlo zbyvajicich byte
5067   8D78 7A			LD	A,D			;test na DE=0
5068   8D79 B3			OR	E
5069   8D7A C2 6F 8D		JP	NZ,L0239		;jeste neni 0, pokracuj dalsim byte
5070   8D7D 78			LD	A,B			;cti CRC
5071   8D7E C5		L0238:	PUSH	BC			;schovej si BC
5072   8D7F 4F			LD	C,A			;schovej si byte k zapisu
5073   8D80 CD A2 8D		CALL	L0240			;zapis 1 pulsu, jine casovani
5074   8D83 06 08		LD	B,008h			;zapisuje se 8 bitu
5075   8D85 79		L0242:	LD	A,C			;byte k zapisu
5076   8D86 1F			RRA				;bit k zapisu do CY
5077   8D87 4F			LD	C,A			;vrat byte k zapisu
5078   8D88 DC A2 8D		CALL	C,L0240			;zapis 1 pulsu (hodnota 1), jine casovani
5079   8D8B D4 94 8D		CALL	NC,L0241		;zapis 1 pulsu (hodnota 0) na magnetofon
5080   8D8E 05			DEC	B			;pocitadlo zapsanych bitu
5081   8D8F C2 85 8D		JP	NZ,L0242		;opakuj pro vsechny bity		
5082   8D92 C1			POP	BC			;obnov BC
5083   8D93 C9			RET				;navrat

5084   8D94 3E 01	L0241:	LD	A,001h			;nastav bit pro vystup na magnetofon
5085   8D96 D3 F6		OUT	(0F6h),A		;zapis do 8255 PC
5086   8D98 CD 5F 8D		CALL	L0243			;casova prodleva pro cteni/zapis na magnetofon
5087   8D9B AF			XOR	A			;nuluj bit pro vystup na magnetofon
5088   8D9C D3 F6		OUT	(0F6h),A		;zapis do 8255 PC
5089   8D9E CD 39 8C		CALL	L0244			;delsi casova prodleva pro cteni/zapis na magnetofon 
5090   8DA1 C9			RET				;navrat

5091   8DA2 3E 01	L0240:	LD	A,001h			;nastav bit pro vystup na magnetofon
5092   8DA4 D3 F6		OUT	(0F6h),A		;zapis do 8255 PC
5093   8DA6 CD 5F 8D		CALL	L0243			;casova prodleva pro cteni/zapis na magnetofon
5094   8DA9 CD 39 8C		CALL	L0244			;delsi casova prodleva pro cteni/zapis na magnetofon 
5095   8DAC AF			XOR	A			;nuluj bit pro vystup na magnetofon
5096   8DAD D3 F6		OUT	(0F6h),A		;zapis do 8255 PC
5097   8DAF CD 39 8C		CALL	L0244			;delsi casova prodleva pro cteni/zapis na magnetofon
5098   8DB2 37			SCF
5099   8DB3 C9			RET

5100   8DB4 2B		V8DB4:	DB	'** MG STOP **',00Dh

			;******************************************************************************
			;LOAD - nacteni bloku dat z magnetofonu
			; vstup: HL= adresa kam ukladat
			; DE= pocet byte-1
			; vyst.: Z= blok dat v pameti je vporadku nacten
			; NZ= chyba pri cteni nebo bylo stisknuto STOP
			; znici: DE, BC, PSW
			;******************************************************************************
5111   8DC2 0E FF	L0269:	LD	C,0FFh
5112   8DC4 E5		L0271:	PUSH	HL			;cilova adresa dat
5113   8DC5 06 00		LD	B,000h			;nuluj CRC
5114   8DC7 CD 49 8F	L0252:	CALL	L0248			;nacteni 1 bitu z nagnetofonu do CY
5115   8DCA CD FA 8E		CALL	L0249			;BYTE - nacteni byte z magnetofonu
5116   8DCD C2 77 85		JP	NZ,L0250		;POP BC, RET
5117   8DD0 0C			INC	C			;nenulovost C (nacteny byte)
5118   8DD1 0D			DEC	C
5119   8DD2 CA D6 8D		JP	Z,L0251			;je nula, skoc
5120   8DD5 77			LD	(HL),A			;uloz precteny byte
5121   8DD6 23		L0251:	INC	HL			;dalsi cilova adresa
5122   8DD7 80			ADD	A,B			;prubezne CRC
5123   8DD8 47			LD	B,A			;vrat zpatky
5124   8DD9 7A			LD	A,D			;uz jsou precteny vsechny byte
5125   8DDA B3			OR	E
5126   8DDB 1B			DEC	DE
5127   8DDC C2 C7 8D		JP	NZ,L0252		;nejsou, dalsi byte
5128   8DDF C3 81 8F		JP	L0253			;nacteni 1 bitu z nagnetofonu

			;******************************************************************************
			;SHEAD - vyhledani a nacteni souboru z magnetofonu
			; vstup: FINDNR 0C1B0h, FINDTP 0C1B1h= cislo, typ hledaneho souboru
			; RAM 0C0F0h modifikace udaju po nacteni hlavicky
			; vyst.: HEAD 0C1B2h= hlavicka nalezeneho souboru
			; C,NZ= chyba, vypise ++ FILE ERROR ++
			; NC,Z= spravne nacteno, vypise ++ READING OK ++
			; pri nalezeni jineho souboru vypise jmeno, hleda dal
			; vola LOAD 08DC2h, ERROR 08B31h
			;******************************************************************************
5129   8DE2 CD 76 8A	L0155:	CALL	L0254			;nastaveni textu ++ FILE ERROR ++
5130   8DE5 CD BE 8E		CALL	L0255			;SYNC - nacteni synchrosmesi pro cteni dat z magnetofonu
5131   8DE8 C0			RET	NZ			;stisknuto STOP - navrat
5132   8DE9 CD E4 8E		CALL	L0256			;HEADIN - nacteni hlavicky souboru
5133   8DEC C0			RET	NZ
5134   8DED 11 B2 C1		LD	DE,0C1B2h		;tabulka hlavicky souboru
5135   8DF0 1A			LD	A,(DE)			;1. byte hlavicky
5136   8DF1 CD 73 8E		CALL	L0257			;BINBCD - konverze BCD kodu na binarni
5137   8DF4 2A 30 C0		LD	HL,(0C030h)		;zacatek bufferu dialogoveho radku
5138   8DF7 CD 3B 81		CALL	L0083			;PREVOD2 - konverze 8 bitu na 2xhex
5139   8DFA 3E 00		LD	A,000h			;pozice kurzoru v buferu
5140   8DFC 32 36 C0		LD	(0C036h),A		;pozice kurzoru v bufferu
5141   8DFF 23			INC	HL			;dalsi pozice v buferu
5142   8E00 36 2F		LD	(HL),02Fh		;'/'
5143   8E02 23			INC	HL			;dalsi pozice v buferu
5144   8E03 13			INC	DE			;dalsi pozice v hlavicce souboru
5145   8E04 1A			LD	A,(DE)			;cti znak z hlavicky
5146   8E05 77		L0245:	LD	(HL),A			;vloz do editacniho buferu
5147   8E06 23			INC	HL			;dalsi pozice v buferu
5148   8E07 36 20		LD	(HL),020h		;vloz mezeru
5149   8E09 23			INC	HL			;dalsi pozice v buferu
5150   8E0A 11 B8 C1		LD	DE,0C1B8h		;8 znaku nazvu souboru
5151   8E0D EB			EX	DE,HL			;prohod ukazatele
5152   8E0E CD C3 81	L0246:	CALL	L0258			;cast TEXTHEAD - prenos hlavicky souboru
5153   8E11 CD 55 88		CALL	L0012			;WRLINE - vypis editacniho bufferu do dialogoveho radku
5154   8E14 2A B2 C1		LD	HL,(0C1B2h)		;tabulka hlavicky souboru
5155   8E17 3A B0 C1		LD	A,(0C1B0h)		;pozadovane cislo souboru
5156   8E1A A7			AND	A
5157   8E1B CA 22 8E		JP	Z,L0259
5158   8E1E BD			CP	L
5159   8E1F C2 8A 8F		JP	NZ,L0260		;obsluha EOL, pipnuti, SHEAD
5160   8E22 3A B1 C1	L0259:	LD	A,(0C1B1h)		;pozadovany typ souboru
5161   8E25 A7			AND	A
5162   8E26 4F			LD	C,A
5163   8E27 CA 2E 8E		JP	Z,L0261
5164   8E2A BC			CP	H
5165   8E2B C2 8A 8F		JP	NZ,L0260		;obsluha EOL, pipnuti, SHEAD
5166   8E2E CD CB 8E	L0261:	CALL	L0262
5167   8E31 C0			RET	NZ
5168   8E32 CD ED 8E		CALL	L0263
5169   8E35 C0			RET	NZ
5170   8E36 21 93 8F		LD	HL,08F93h		;text '** READING OK **'
5171   8E39 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
5172   8E3C C9			RET

5173   8E3D 00		V8E3D:	DB	000h

			;******************************************************************************
			;DECPAR - nacteni cisla souboru
			; vyst.: nacte cislo souboru, prevede ho na dekadicke cislo
			;******************************************************************************
5174   8E3E 21 91 82	L0154:	LD	HL,08291h		;text '** ERROR IN DATA **'
5175   8E41 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
5176   8E44 2A 72 C0		LD	HL,(0C072h)		;nastaveni pri analyze bufferu
5177   8E47 CD F7 80		CALL	L0025			;PARIN - konverze hex na 8 bitu
5178   8E4A D8			RET	C			;chyba konverze, navrat
5179   8E4B 23			INC	HL
5180   8E4C 22 72 C0		LD	(0C072h),HL		;nastaveni pri analyze bufferu
5181   8E4F FE 63		CP	063h			;pozadovane cislo souboru vetsi nez 99?
5182   8E51 3F			CCF				;invertuj CY
5183   8E52 D8			RET	C			;je mimo, navrat
5184   8E53 4F			LD	C,A			;schovej cislo souboru
5185   8E54 0F			RRCA				;prohod nibble
5186   8E55 0F			RRCA
5187   8E56 0F			RRCA
5188   8E57 0F			RRCA
5189   8E58 E6 0F		AND	00Fh			;jen nejnizsi 4 bity
5190   8E5A 87			ADD	A,A			;A*2
5191   8E5B 47			LD	B,A			;B=A*2
5192   8E5C 87			ADD	A,A			;A*4
5193   8E5D 87			ADD	A,A			;A*8
5194   8E5E 80			ADD	A,B			;A*10
5195   8E5F 47			LD	B,A			;uloz mezivysledek
5196   8E60 79			LD	A,C			;puvodni byte
5197   8E61 E6 0F		AND	00Fh			;jen 4 nejnizsi bity
5198   8E63 80			ADD	A,B			;secti s B
5199   8E64 E5		L0883:	PUSH	HL
5200   8E65 21 00 C3		LD	HL,0C300h		;ulozi se 000h,0C3h,072h,08Eh > JP 08E72h
5201   8E68 22 F0 C0		LD	(0C0F0h),HL		;vektor modifikace MGLD, MGSV, MGEND
5202   8E6B 21 72 8E		LD	HL,08E72h		;coz je odkaz na RET
5203   8E6E 22 F2 C0		LD	(0C0F2h),HL
5204   8E71 E1			POP	HL
5205   8E72 C9			RET

			;******************************************************************************
			;BINBCD - konverze BCD kodu na binarni
			; vstup: A= BCD kod
			; vyst.: A= binarni kod
			; znici: HL, B, PSW
			;******************************************************************************
5206   8E73 67		L0257:	LD	H,A
5207   8E74 06 08		LD	B,008h			;
5208   8E76 AF			XOR	A
5209   8E77 29		L0264:	ADD	HL,HL
5210   8E78 8F			ADC	A,A
5211   8E79 27			DAA
5212   8E7A 05			DEC	B
5213   8E7B C2 77 8E		JP	NZ,L0264
5214   8E7E C9			RET

			;******************************************************************************
			;obsluha prikazu MONITORu MGSV
			;******************************************************************************
5215   8E7F CD 3E 8E	L8E7F:	CALL	L0154			;DECPAR - nacteni cisla souboru
5216   8E82 DA 49 80		JP	C,L0032			;navrat do MONITORu, vypis chyboveho hlaseni
5217   8E85 21 46 80		LD	HL,08046h		;navratova adresa do cyhboveho hlaseni
5218   8E88 E5			PUSH	HL			;uloz na vrchol SP
5219   8E89 6F			LD	L,A			;cislo souboru v L
5220   8E8A 3A 36 C1		LD	A,(0C136h)		;typ souboru pro MGSV, MGLD, MGEND
5221   8E8D 67			LD	H,A			;pozadovany typ souboru v H
5222   8E8E 22 B2 C1		LD	(0C1B2h),HL		;tabulka hlavicky souboru
5223   8E91 CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu - pocatecni adresa
5224   8E94 EB			EX	DE,HL			;vysledek zkopiruj do HL
5225   8E95 22 B4 C1		LD	(0C1B4h),HL		;adresa zacatku dat souboru
5226   8E98 E5			PUSH	HL
5227   8E99 21 72 C0		LD	HL,0C072h		;nastaveni pri analyze bufferu
5228   8E9C 34			INC	(HL)
5229   8E9D CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu - koncova adresa
5230   8EA0 E1			POP	HL			;pocatecni adresa dat
5231   8EA1 7B		L0877:	LD	A,E			;vypocet delky ukladanych dat
5232   8EA2 95			SUB	L
5233   8EA3 6F			LD	L,A
5234   8EA4 7A			LD	A,D
5235   8EA5 9C			SBC	A,H
5236   8EA6 67			LD	H,A
5237   8EA7 DA 49 80		JP	C,L0032			;zaporna delka - navrat do MONITORu, vypis chyboveho hlaseni
5238   8EAA 22 B6 C1		LD	(0C1B6h),HL		;delka souboru - 1
5239   8EAD 2A 72 C0	L0892:	LD	HL,(0C072h)		;nastaveni pri analyze bufferu
5240   8EB0 23			INC	HL
5241   8EB1 CD C0 81		CALL	L0265			;TEXTHEAD - prenos dlavicky souboru
5242   8EB4 CD 60 8F		CALL	L0266			;PRGOUT - zapis bloku dat do souboru na magnetofon
5243   8EB7 21 B4 8D		LD	HL,V8DB4		;'** MG STOP **'
5244   8EBA 22 74 C0		LD	(0C074h),HL		;zacatek textu hlaseni
5245   8EBD C9			RET

			;******************************************************************************
			;SYNC - nacteni synchrosmesi pro cteni dat z magnetofonu
			; vyst.: zasynchronizovani systemu pro HEADIN 08EE4h
			;******************************************************************************
5246   8EBE CD CB 8E	L0255:	CALL	L0262			;nacteni 256 bitu synchrosmesi
5247   8EC1 C0			RET	NZ			;stisknuto STOP, navrat
5248   8EC2 CD FA 8E		CALL	L0249			;BYTE - nacteni byte z magnetofonu
5249   8EC5 FE 55		CP	055h			;byte pred vlastnimi daty
5250   8EC7 C2 BE 8E		JP	NZ,L0255		;nebylo, opakuj znovu
5251   8ECA C9			RET

5252   8ECB DB F6	L0262:	IN	A,(0F6h)		;cti PC 8255
5253   8ECD 2F			CPL				;neguj
5254   8ECE E6 10		AND	010h			;odmaskuj jen tlacitko STOP
5255   8ED0 C0			RET	NZ			;bylo stisknuto - navrat
5256   8ED1 2E 40		LD	L,040h
5257   8ED3 CD 49 8F	L0267:	CALL	L0248			;nacteni 1 bitu z nagnetofonu do CY
5258   8ED6 DA CB 8E		JP	C,L0262			;cekej na CY=0
5259   8ED9 2D			DEC	L			;pocitadlo pruchodu
5260   8EDA C2 D3 8E		JP	NZ,L0267		;pro vsech 40h opakovani
5261   8EDD CD 49 8F	L0268:	CALL	L0248			;nacteni 1 bitu z nagnetofonu do CY
5262   8EE0 D2 DD 8E		JP	NC,L0268		;cekej na CY=1
5263   8EE3 C9			RET


			;******************************************************************************
			;HEADIN - nacteni hlavicky souboru
			; vvst.: HEAD 0C1B2h= hlavicka souboru
			;******************************************************************************
5264   8EE4 21 B2 C1	L0256:	LD	HL,0C1B2h		;tabulka hlavicky souboru
5265   8EE7 11 0D 00		LD	DE,0000Dh		;delka hlavicky souboru
5266   8EEA C3 C2 8D		JP	L0269			;LOAD - nacteni bloku dat z magnetofonu

5267   8EED 2A B6 C1	L0263:	LD	HL,(0C1B6h)		;delka souboru - 1
5268   8EF0 EB			EX	DE,HL
5269   8EF1 2A B4 C1		LD	HL,(0C1B4h)		;adresa zacatku dat souboru
5270   8EF4 CD F0 C0	L0872:	CALL	L0270			;navratovy vektor po MGSV, MGLD a MGEND
5271   8EF7 C3 C4 8D		JP	L0271			;cast LOAD - nacteni bloku dat z magnetofonu

			;******************************************************************************
			;BYTE - nacteni byte z magnetofonu
			;******************************************************************************
5272   8EFA C5		L0249:	PUSH	BC			;schovej si BC
5273   8EFB 06 08		LD	B,008h			;byte ma 8 bitu
5274   8EFD 0E 00		LD	C,000h			;nuluj precteny byte
5275   8EFF CD 49 8F	L0272:	CALL	L0248			;nacteni 1 bitu z nagnetofonu do CY
5276   8F02 79			LD	A,C			;do A predchozi vysledek
5277   8F03 1F			RRA				;nasunuti bitu z CY do Acc
5278   8F04 4F			LD	C,A			;dej vysledek zpatky
5279   8F05 05			DEC	B			;pocitadlo prijatych bitu
5280   8F06 C2 FF 8E		JP	NZ,L0272		;opakuj pro vsech 8 bitu
5281   8F09 DB F6		IN	A,(0F6h)		;cti data z PC
5282   8F0B 2F			CPL				;invertuj data
5283   8F0C E6 10		AND	010h			;test na klavesu STOP
5284   8F0E 79			LD	A,C			;precteny byte do Acc
5285   8F0F C1			POP	BC			;obnov BC
5286   8F10 C9			RET				;navrat

			;******************************************************************************
			;Obsluha prikazu MONITORu BASIC
			;******************************************************************************
5287   8F11 21 00 A0	L8F11:	LD	HL,0A000h		;zdrojova data BASICU programu (Basic je posunuty vo verzii LAN)
5288   8F14 11 00 00		LD	DE,00000h		;cilova adresa pro presun dat
5289   8F17 7E		L0273:	LD	A,(HL)	 		;cti byte z EPROM
5290   8F18 12			LD	(DE),A	 		;zapis byte do RAM
5291   8F19 23			INC	HL	 		;dalsi zdrojova adresa
5292   8F1A 13			INC	DE	 		;dalsi cilova adresa
5293   8F1B 7C			LD	A,H	 		;kontrola na konec BASICU,
5294   8F1C FE C0		CP	0C0h	 		;ktery je na adrese 0C0FFh (povodne BC)
5295   8F1E C2 17 8F		JP	NZ,L0273 		;jeste nejsou vsechna data, opakuj dalsi byte		
5296   8F21 C3 00 00		JP	L0000			;spusteni inerpretu BASIC

			;******************************************************************************
			;SSKIP - ignorovani mezer v editacnim radku
			;******************************************************************************
5297   8F24 2B		L0112:	DEC	HL
5298   8F25 23		L0275:	INC	HL
5299   8F26 7E			LD	A,(HL)
5300   8F27 FE 20		CP	020h
5301   8F29 CA 25 8F		JP	Z,L0275
5302   8F2C C9			RET

			;******************************************************************************
			;OUTSYNC - zapis synchrosmesi pred hlavickou na magnetofon (LEADER)
			;******************************************************************************
5303   8F2D 06 FF	L0278:	LD	B,0FFh			;pocet pulsu synchrosmesi
5304   8F2F CD 41 8F		CALL	L0276			;zapise B pulsu do magnetofonu
5305   8F32 3E 55		LD	A,055h			;byte k zapisu na magnetofon
5306   8F34 CD 7E 8D		CALL	L0238			;zapis byte z A na magnetofon
5307   8F37 C9			RET

			;******************************************************************************
			;DTSYNC - zapis synchrosmesi pro zapis dat na magnetofon
			;******************************************************************************
5308   8F38 06 80	L0280:	LD	B,080h			;pocet pulsu synchrosmesi
5309   8F3A CD 41 8F		CALL	L0276			;zapise B pulsu do magnetofonu
5310   8F3D CD A2 8D		CALL	L0240			;zapis 1 pulsu, jine casovani
5311   8F40 C9			RET				;navrat

			;******************************************************************************
			;zapise B pulsu do magnetofonu
			;******************************************************************************
5312   8F41 CD 94 8D	L0276:	CALL	L0241			;zapis 1 puls (bit) na magnetofon
5313   8F44 05			DEC	B			;sniz pocitadlo pulsu synch. smesi
5314   8F45 C2 41 8F		JP	NZ,L0276		;opakuj dany pocet
5315   8F48 C9			RET				;navrat

			;******************************************************************************
			;Nacteni 1 bitu z MGF do CY
			;******************************************************************************
5316   8F49 DB F6	L0248:	IN	A,(0F6h)		;cti data z magnetofonu
5317   8F4B 17			RLA				;7-mi bit do CY
5318   8F4C DA 49 8F		JP	C,L0248			;je nastaven, cekej na sestupnou hranu
5319   8F4F DB F6	L0277:	IN	A,(0F6h)		;cti data z magnetofonu
5320   8F51 17			RLA				;7-mi bit do CY
5321   8F52 D2 4F 8F		JP	NC,L0277		;neni nastaven, cekej na vzestupnou hranu
5322   8F55 3A 7C C0		LD	A,(0C07Ch)		;konstanta rychlosti cteni z magnetofonu
5323   8F58 17			RLA				;konstanta *2
5324   8F59 C6 08		ADD	A,008h			;konstanta +8
5325   8F5B 00			NOP
5326   8F5C 00			NOP
5327   8F5D C3 62 8D		JP	L0221			;vykonani casove prodlevy, precteni bitu do CY

			;******************************************************************************
			;PRGOUT - zapis bloku dat do souboru na magnetofon
			; vstup: HEAD 0C1B2h= cislo, typ, pocatek, delka, nazev
			; RAM 0C0F0h= modifikace zapisu po ulozeni hlavicky
			;******************************************************************************
5328   8F60 06 FF	L0266:	LD	B,0FFh			;pocet pulsu pro zapis do magnetofonu
5329   8F62 CD 41 8F		CALL	L0276			;zapise B pulsu do magnetofonu
5330   8F65 CD 2D 8F		CALL	L0278			;OUTSYNC - zapis synchrosmesi pred hlavickou na magnetofon (LEADER)
5331   8F68 21 B2 C1		LD	HL,0C1B2h		;tabulka hlavicky souboru
5332   8F6B 11 0D 00		LD	DE,0000Dh		;delka hlavicky
5333   8F6E CD 6C 8D		CALL	L0279			;TAPEOUT - zapis bloku dat na magnetofon
5334   8F71 CD 38 8F		CALL	L0280			;DTSYNC - zapis synchrosmesi pro zapis dat na magnetofon
5335   8F74 CD F0 C0		CALL	L0270			;navratovy vektor po MGSV, MGLD a MGEND
5336   8F77 2A B6 C1		LD	HL,(0C1B6h)		;delka souboru - 1
5337   8F7A EB			EX	DE,HL
5338   8F7B 2A B4 C1		LD	HL,(0C1B4h)		;adresa zacatku dat souboru
5339   8F7E C3 6C 8D		JP	L0279			;TAPEOUT - zapis bloku dat na magnetofon

5340   8F81 CD 49 8F	L0253:	CALL	L0248			;nacteni 1 bitu z nagnetofonu
5341   8F84 CD FA 8E	L0095:	CALL	L0249			;BYTE - nacteni byte z magnetofonu
5342   8F87 A8			XOR	B
5343   8F88 E1			POP	HL
5344   8F89 C9			RET

5345   8F8A CD B6 8B	L0260:	CALL	L0281			;obsluha klavesy EOL
5346   8F8D CD A3 88		CALL	L0037			;standardni pipnuti
5347   8F90 C3 E2 8D		JP	L0155			;SHEAD - vyhledani a nacteni souboru z magnetofonu

5348   8F93 2B		V8F93:	DB	'** READING OK **',00Dh


			;******************************************************************************
			;TRANSFER - nacteni bloku dat z ROM modulu pripojeneho na K2
			; vstup: parametry se ukladaji v programu tesne za volanim 
			; sluzby CALL TRANSFER : adresa zacatku v ROM modulu, 
			; pocet ctenych byte-1, adresa ulozeni v RAM
			;******************************************************************************
5362   8FA4 3E 90	L8FA4:	LD	A,090h			;nastaveni 8255 v ROM modulu
5363   8FA6 D3 FB		OUT	(0FBh),A
5364   8FA8 E3			EX	(SP),HL			;adresy a delka prenasenych dat
5365   8FA9 7E			LD	A,(HL)			;LOW adresa EPROM
5366   8FAA D3 F9		OUT	(0F9h),A		;nastav
5367   8FAC 23			INC	HL			;dalsi byte
5368   8FAD 7E			LD	A,(HL)			;HIGH adresa EPROM
5369   8FAE D3 FA		OUT	(0FAh),A		;nastav
5370   8FB0 23			INC	HL
5371   8FB1 4E			LD	C,(HL)			;LOW byte delky prenasenych dat
5372   8FB2 23			INC	HL
5373   8FB3 46			LD	B,(HL)			;HIGH byte delky prenasenych dat
5374   8FB4 04			INC	B			;zvetsi delku dat o 00100h
5375   8FB5 23			INC	HL
5376   8FB6 5E			LD	E,(HL)			;LOW byte cilove adresy
5377   8FB7 23			INC	HL
5378   8FB8 56			LD	D,(HL)			;HIGH byte cilove adresy
5379   8FB9 23			INC	HL
5380   8FBA DB F8	L0286:	IN	A,(0F8h)		;cti byte z EPROM
5381   8FBC 12			LD	(DE),A			;uloz na cilovou adresu
5382   8FBD 13			INC	DE			;dalsi cilova adresa
5383   8FBE 0B			DEC	BC			;pocitadlo prenasenych byte
5384   8FBF DB F9		IN	A,(0F9h)		;precti LOW byte adresy EPROM
5385   8FC1 3C			INC	A			;dalsi LOW byte adresy EPROM
5386   8FC2 D3 F9		OUT	(0F9h),A		;nastav adresu LOW EPROM
5387   8FC4 C2 CC 8F		JP	NZ,L0285		;neni-li preteceni, skoc
5388   8FC7 DB FA		IN	A,(0FAh)		;precti HIGH byte adres EPROM
5389   8FC9 3C			INC	A			;dalsi HIGH adresy EPROM
5390   8FCA D3 FA		OUT	(0FAh),A		;nastav adresu HIGH EPROM
5391   8FCC 78		L0285:	LD	A,B			;test na delku prenesenych dat
5392   8FCD B7		L0284:	OR	A
5393   8FCE C2 BA 8F		JP	NZ,L0286		;neni jseste konec, dalsi byte
5394   8FD1 3E FF		LD	A,0FFh
5395   8FD3 D3 FA		OUT	(0FAh),A
5396   8FD5 E3			EX	(SP),HL			;adresa navratu z TRANSF
5397   8FD6 C9			RET				;navrat za data za volanim TRANS

			;******************************************************************************
			;obsluha prikazu MONITORu JOBzzzzllllcccc
			;******************************************************************************
5398   8FD7 3E 90	L8FD7:	LD	A,090h			;nastaveni 8255 v ROM modulu
5399   8FD9 D3 FB		OUT	(0FBh),A		;nastav 8255
5400   8FDB CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu
5401   8FDE 7B			LD	A,E			;LOW byte adresy zdroje - ..zz
5402   8FDF D3 F9		OUT	(0F9h),A
5403   8FE1 7A			LD	A,D			;HIGH byte adresy zdroje - zz..
5404   8FE2 D3 FA		OUT	(0FAh),A
5405   8FE4 CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu
5406   8FE7 42			LD	B,D
5407   8FE8 04			INC	B			;uprav deku ctenych dat
5408   8FE9 4B		L0282:	LD	C,E
5409   8FEA C5			PUSH	BC			;delka prenasenych dat - llll
5410   8FEB CD 4B 81		CALL	L0040			;RADR - vstupni hex konverze 16 bitu
5411   8FEE 62		L0283:	LD	H,D
5412   8FEF 6B			LD	L,E			;v HL je cilova adresa dat - cccc
5413   8FF0 C1			POP	BC
5414   8FF1 CD BA 8F		CALL	L0286			;vlastni cteni dat z ROM modulu - cast TRANSFER
5415   8FF4 2B			DEC	HL
5416   8FF5 23		L0287:	INC	HL
5417   8FF6 7E			LD	A,(HL)
5418   8FF7 FE 20		CP	020h
5419   8FF9 CA F5 8F		JP	Z,L0287
5420   8FFC C9			RET
; prazdne miesto
5421   8FFD 00		V8FFD:	DB	000h,055h,052h

			;******************************************************************************
			;obsluha prikazu MONITORu DEMO
			;******************************************************************************
; vo verzii LAN zacina presne na adrese 9000

5430   9000 21 00 98		LD	HL,9800H		; zaciatok dat
5431   9003 11 00 00		LD	DE,0000H		; kam presunut
5432   9006 CD 12 90		CALL	L0289			; presun dat 9800 - bfff
5433   9009 21 FD 27		LD	HL,27FDH
5434   900C 22 7A 5E		LD	(5E7AH),HL
5435   900F C3 00 00		JP	0000h			; spusti demo
5436   9012 7E		L0289:	LD	A,(HL)			; podprogram na presun dat
5437   9013 12			LD 	(DE),A
5438   9014 23			INC 	HL
5439   9015 13			INC 	DE
5440   9016 7C			LD 	A,H
5441   9017 FE C0		CP 	0C0H
5442   9019 C2 12 90		JP 	NZ,L0289
5443   901C C9			RET				; koniec presunu dat
			;******************************************************************************
			;obsluha prikazu MONITORu SEND
			;******************************************************************************
5444   901D 21 46 83		LD HL,8346H			; priprav hlasenie 'Error in address'
5445   9020 22 74 C0		LD (0C074H),HL			; do systemovej premennej MESAGE
5446   9023 3E 52		LD A,52H			; 'R' prikaz pre druhu stranu (prijmi moje data)
5447   9025 32 B2 C1		LD (0C1B2H),A			; do systemovej premennej NUMFIL
5448   9028 CD 9A 95		CALL L0290			; ak nie je nastaveny flag, zmen hlasku na 'LAN off'
5449   902B CA 49 80		JP Z,L0032			; vypis 'LAN off' a prikaz SEND konci
5450   902E CD 84 95		CALL L0291			; hladaj v bufri dalsi znak okrem medzery
5451   9031 CD 60 91		CALL L0292			; nacitaj adresu prijemcu (dva znaky hex)
5452   9034 DA 49 80		JP C,L0032			; ak nie je hex, vypis chyboveho hlasenia 'Errror in address'
5453   9037 2A 72 C0		LD HL,(0C072H)			; ukazatel v bufri
5454   903A 7E			LD A,(HL)			; nacitak znak
5455   903B FE 2F		CP 2FH				; je to '/' ? ak ano, musi nasledovat typ dat
5456   903D C2 49 90		JP NZ,L0293			; nie je, budu sa dekodovat parametre bloku
5457   9040 CD 0F 91		CALL L0294			; nacitaj typ dat, musi byt G, B alebo T, rovno nastavi aj blok
5458   9043 C2 6C 92		JP NZ,L0295			; pri inych typoch hlasenie 'LAN off'
5459   9046 C3 7C 90		JP L0296			; prepocitaj parametre bloku a odosli blok
; teraz sa z prikazu dekoduju jednotlive parametre bloku
; pricom sa preskakuju separacne znaky, ktore mozu byt takmer akekolvek,
; nielen predpisane ';' alebo '-', ale nie '/'
5460   9049 CD 92 95	L0293:	CALL L0297			; dalsi znak v bufri (preskoci sa odporucany znak ';')
5461   904C CD 6E 91		CALL L0298			; nacitaj pociatocnu adresu
5462   904F DA 49 80		JP C,L0032			; 'Error in adrress'
5463   9052 CD 92 95		CALL L0297			; dalsi znak (preskoci sa odporucany znak '-')
5464   9055 CD 76 91		CALL L0299			; nacitaj koncovu adresu
5465   9058 DA 49 80		JP C,L0032			; 'Error in adrress'
5466   905B 2A 72 C0		LD HL,(0C072H)			; ak nie je treti parameter, musi nasledovat '/'
5467   905E 7E			LD A,(HL)			; citaj z bufra
5468   905F FE 2F		CP 2FH				; je to '/' ?
5469   9061 C2 6D 90		JP NZ,L0300			; ak nie, citaj este cielovu adresu
5470   9064 CD E5 90		CALL L0301			; nacitaj typ suboru (G, D, T alebo M)
5471   9067 C2 6C 92		JP NZ,L0295  			; ak nie je ani jeden z nich, vypis 'No command'
5472   906A C3 7C 90		JP L0296			; prepocitaj parametre bloku a odosli blok
; docita cielovu adresu
5473   906D CD 92 95	L0300:	CALL L0297			; posun sa v bufri na dalsi znak (preskoci ';')
5474   9070 CD 7E 91		CALL L0302			; nacitaj adresu, kam sa maju data ulozit
5475   9073 DA 49 80		JP C,L0032			; 'Error in adrress'
5476   9076 CD C5 90		CALL L0303			; teraz uz musi nasledovat '/' a typ suboru
5477   9079 C2 6C 92		JP NZ,L0295			; ak nie je 'G', 'M' alebo 'D' vypis 'No command'
5478   907C CD 82 90	L0296:	CALL L0304			; nacitaj parametre bloku dat a odosli data
5479   907F C3 49 80		JP L0032			; vypis hlasenie o (ne)uspesnosti prenosu
; uprava zahlavia dat (vypocita sa dlzka dat) a odoslanie celeho bloku dat
5480   9082 2A B6 C1	L0304:	LD HL,(0C1B6H)			; nacitaj cielovu adresu (do) z LENFIL
5481   9085 EB			EX DE,HL
5482   9086 2A B4 C1		LD HL,(0C1B4H)			; a pociatocnu adresu (od) z ADRFIL
5483   9089 7B			LD A,E				; vypocitaj rozdiel
5484   908A 95			SUB L
5485   908B 6F			LD L,A
5486   908C 7A			LD A,D
5487   908D 9C			SBC A,H
5488   908E 67			LD H,A
5489   908F 22 B6 C1		LD (0C1B6H),HL			; uloz spat do LENFIL
5490   9092 D8			RET C				; chyba, ak cielova adresa je mensia
5491   9093 CD AC 90		CALL L0305			; odosli zahlavie bloku
5492   9096 CD 3A 95		CALL L0306			; vypis stav prenosu zahlavia
5493   9099 3A BF C1		LD A,(0C1BFH)			; hlavicka uspesne odoslana?
5494   909C A7			AND A
5495   909D C0			RET NZ				; ak nie, tak je koniec
5496   909E 2A B6 C1		LD HL,(0C1B6H)			; teraz sa bude odosielat hlavny blok dat
5497   90A1 EB			EX DE,HL		       	; nastav zaciatok a dlzku
5498   90A2 2A B4 C1		LD HL,(0C1B4H)
5499   90A5 CD A5 93		CALL L0307			; odosli blok dat
5500   90A8 CD 3A 95		CALL L0306			; vypis stav prenosu bloku dat
5501   90AB C9			RET 				; a tym sa prenos konci, aneb A to je vse pratele!
; odoslanie zahlavia dat, pouziju sa systemove premenne
5502   90AC 21 88 94	L0305:	LD HL,9488H			; hlasenie 'LAN actived, wait please'
5503   90AF 22 74 C0		LD (0C074H),HL			; do premenej MESAGE
5504   90B2 CD 89 8A		CALL L0308  			; pipni a vypis hlasenie
5505   90B5 3A BE C1		LD A,(0C1BEH) 			; nacitaj NETID
5506   90B8 32 B0 C1		LD (0C1B0H),A			; uloz do hlavicky
5507   90BB 21 B0 C1		LD HL,0C1B0H			; zaciatok hlavicky v systemovych premennych
5508   90BE 11 0A 00		LD DE,000AH			; dlzka 10 bajtov
5509   90C1 CD A5 93		CALL L0307			; odosli zahlavie ako blok 10 bajtov
5510   90C4 C9			RET
;
5511   90C5 2A 72 C0	L0303:	LD HL,(0C072H)			; pozicia v bufri
5512   90C8 7E			LD A,(HL)			; nacitaj
5513   90C9 FE 2F		CP 2FH				; je to '/' ?
5514   90CB CA D5 90		JP Z,L0309			; musi nasledovat G, M alebo D
5515   90CE 21 92 83		LD HL,8392H			; hlasenie 'No command'
5516   90D1 22 74 C0		LD (0C074H),HL			; nastav do MESAGE
5517   90D4 C9			RET
;
5518   90D5 CD 92 95	L0309:	CALL L0297			; posun na dalsi znak v bufri
5519   90D8 7E			LD A,(HL)			; nacitaj
5520   90D9 32 B3 C1		LD (0C1B3H),A			; uloz ako TYPFIL
5521   90DC FE 47		CP 47H				; 'G' (grafika) ?
5522   90DE C8			RET Z
5523   90DF FE 4D		CP 4DH				; 'M' (code) ?
5524   90E1 C8			RET Z
5525   90E2 FE 44		CP 44H				; 'D' (data) ?
5526   90E4 C9			RET
; skontroluje sa typ bloku, a urci cielovu adresu na zaklade pociatocnej adresy
; okrem typu G, kde sa priamo urci zaciatok VideoRAM
5527   90E5 CD 92 95	L0301:	CALL L0297			; posun na dalsi znak v bufri
5528   90E8 7E			LD A,(HL)			; nacitaj
5529   90E9 32 B3 C1		LD (0C1B3H),A			; uloz typ bloku (G, D, M, T)
5530   90EC FE 47		CP 47H				; 'G' (grafika) ?
5531   90EE CA 01 91		JP Z,L0310
5532   90F1 FE 44		CP 44H				; 'D' (data) ?
5533   90F3 CA 08 91		JP Z,L0311
5534   90F6 FE 54		CP 54H				; 'T' (text) ?
5535   90F8 CA 08 91		JP Z,L0311
5536   90FB FE 4D		CP 4DH				; 'M' (code) ?
5537   90FD CA 08 91		JP Z,L0311
5538   9100 C9			RET
; obrazove data
5539   9101 21 00 C0	L0310:	LD HL,0C000H			; nastav zaciatok VideoRAM do NAMFIL
5540   9104 22 B8 C1		LD (0C1B8H),HL			; ako cielovu adresu
5541   9107 C9			RET
; ostatne data
5542   9108 2A B4 C1	L0311:	LD HL,(0C1B4H)			; skopiruj ADRFIL do NAMFIL
5543   910B 22 B8 C1		LD (0C1B8H),HL			; ako cielovu adresu
5544   910E C9			RET
; nacitaj typ dat (G, B, alebo T)
; inak vrati NZ
5545   910F CD 92 95	L0294:	CALL L0297			; posun v bufri na dalsi znak
5546   9112 7E			LD A,(HL)			; a nacitaj ho
5547   9113 32 B3 C1	L0320:	LD (0C1B3H),A			; uloz do premennej TYPFIL
5548   9116 FE 47		CP 47H				; 'G' (grafika) ?
5549   9118 C2 1E 91		JP NZ,L0312			; WTF ????
5550   911B C3 2C 91		JP L0313			; nastav blok na VideoRAM
5551   911E FE 42	L0312:	CP 42H				; 'B' (Basic program) ?
5552   9120 C2 26 91		JP NZ,L0314			; WTF ????
5553   9123 C3 3C 91		JP L0315			; nastav blok na Basic
5554   9126 FE 54	L0314:	CP 54H				; 'T' (text) ?
5555   9128 CA 4C 91		JP Z,L0316
5556   912B C9			RET
; nastav VideoRAM ako blok dat na presun po sieti
5557   912C 21 00 C0	L0313:	LD HL,0C000H			; VideoRAM
5558   912F 22 B4 C1		LD (0C1B4H),HL			; adresa zaciatku bloku dat
5559   9132 22 B8 C1		LD (0C1B8H),HL			; aj cielova adresa
5560   9135 21 00 FD		LD HL,0FD00H			; dlzka suboru (cela VideoRAM)
5561   9138 22 B6 C1		LD (0C1B6H),HL			; ako adresa konca bloku
5562   913B C9			RET
; nastav program v Basicu ako blok dat na presun
5563   913C 21 00 24	L0315:	LD HL,2400H			; zaciatok Basic-u
5564   913F 22 B4 C1		LD (0C1B4H),HL			; ako zaciatok bloku
5565   9142 22 B8 C1		LD (0C1B8H),HL			; aj cielova adresa
5566   9145 2A 7A 5E		LD HL,(5E7AH)			; koniec programu v Basic-u (asi)
5567   9148 22 B6 C1		LD (0C1B6H),HL			; ako koniec bloku
5568   914B C9			RET
; nastavi sa ukazatel na buffer ako zaciatok bloku dat a hlada sa Enter, ktory ukonci blok dat
5569   914C CD 92 95	L0316:	CALL L0297			; posun na dalsi znak v bufri
5570   914F 22 B4 C1		LD (0C1B4H),HL			; uloz do premnnych ADRFIL
5571   9152 22 B8 C1		LD (0C1B8H),HL			; a NAMFIL
5572   9155 7E		L0317:	LD A,(HL)			; hladaj znak 0Dh 'Enter'
5573   9156 23			INC HL
5574   9157 FE 0D		CP 0DH
5575   9159 C2 55 91		JP NZ,L0317
5576   915C 22 B6 C1		LD (0C1B6H),HL			; uloz ako koniec bloku
5577   915F C9			RET
; z prikazu nacitaj prvy parameter, co je adresa prijemncu
5578   9160 2A 72 C0	L0292:	LD HL,(0C072H)			; pozicia v bufri
5579   9163 CD F7 80		CALL L0025			; konverzia dvoch hex znakov na bajt
5580   9166 22 72 C0		LD (0C072H),HL			; uloz novu poziciu
5581   9169 D8			RET C				; pri chybe sa vrat s CY=1
5582   916A 32 B1 C1		LD (0C1B1H),A			; uloz bajt do premennej FINDTP (typ suboru)
5583   916D C9			RET
; nacitaj pociatocnu adresu
5584   916E CD 86 91	L0298:	CALL L0318			; nacitaj 4 znaky ako adresu
5585   9171 D8			RET C				; nie je adresa
5586   9172 22 B4 C1		LD (0C1B4H),HL			; uloz ako zaciatok bloku
5587   9175 C9			RET
; nacitaj koncovu adresu
5588   9176 CD 86 91	L0299:	CALL L0318			; nacitaj 4 znaky ako koncovu adresu
5589   9179 D8			RET C				; nie je adresa
5590   917A 22 B6 C1		LD (0C1B6H),HL			; uloz ako koniec bloku (neskor sa prepocita na dlzku)
5591   917D C9			RET
; nacitaj cielovu adresu
5592   917E CD 86 91	L0302:	CALL L0318			; nacitaj 4 znaky ako koncovu adresu
5593   9181 D8			RET C				; nie je adresa
5594   9182 22 B8 C1		LD (0C1B8H),HL			; uloz ako cielovu adresu
5595   9185 C9			RET
; nacitaj nasledujuce 4 znaky z bufra ako hex adresu
5596   9186 2A 72 C0	L0318:	LD HL,(0C072H)			; pozicia v bufri
5597   9189 CD 09 81		CALL L0031			; nacitaj hex adresu do DE
5598   918C D8			RET C
5599   918D 22 72 C0		LD (0C072H),HL			; uloz poziciu do INPUT
5600   9190 EB			EX DE,HL			; vrat adresu v HL
5601   9191 C9			RET
			;******************************************************************************
			;obsluha prikazu MONITORu READ
			;******************************************************************************
5602   9192 21 46 83		LD HL,8346H			; priprav hlasenie 'Error in address'
5603   9195 22 74 C0		LD (0C074H),HL			; do systemovej premennej MESAGE
5604   9198 3E 54		LD A,54H			; 'T' prikaz pre druhu stranu (posli mi data, co chcem)
5605   919A 32 B2 C1		LD (0C1B2H),A			; do systemovej premennej TYPFIL
5606   919D CD 9A 95		CALL L0290			; ak nie je nastaveny flag, zmen hlasku na 'LAN off'
5607   91A0 CA 49 80		JP Z,L0032			; vypis 'LAN off', prikaz konci
5608   91A3 CD 84 95		CALL L0291			; hladaj v bufri dalsi znak okrem medzery
5609   91A6 CD 60 91		CALL L0292			; nacitaj adresu odosielatela
5610   91A9 DA 49 80		JP C,L0032			; ak nie je hex, vypis chyboveho hlasenia
5611   91AC 2A 72 C0		LD HL,(0C072H)			; ukazatel v bufri
5612   91AF 7E			LD A,(HL)			; nacitak znak
5613   91B0 FE 2F		CP 2FH				; je to '/' ? ak ano, musi nasledovat typ dat
5614   91B2 C2 C7 91		JP NZ,L0319			; nacitaj zvysne parametre
5615   91B5 CD 92 95		CALL L0297			; dalsi znak v bufri (preskoci sa odporucany znak ';')
5616   91B8 7E			LD A,(HL)			; nacitaj znak z bufra
5617   91B9 FE 54		CP 54H				; je to 'T'? 'T' je nepripustne!
5618   91BB CA 6C 92		JP Z,L0295			; hlasenie 'LAN off'
5619   91BE CD 13 91		CALL L0320			; uloz do premennej TYPFIL typ dat (G, B)
5620   91C1 C2 6C 92		JP NZ,L0295			; iny typ, hlas 'LAN off'
5621   91C4 C3 FA 91		JP L0321			; pokracuj nizsie
; nacitanie parametrov z prikazoveho riadku
5622   91C7 CD 92 95	L0319:	CALL L0297			; dalsi znak v bufri
5623   91CA CD 6E 91		CALL L0298			; nacitaj pociatocnu adresu bloku
5624   91CD DA 6C 92		JP C,L0295			; hlasenie 'LAN off'
5625   91D0 CD 92 95		CALL L0297			; dalsi znak v bufri
5626   91D3 CD 76 91		CALL L0299			; nacitaj koncovu adresu bloku
5627   91D6 DA 49 80		JP C,L0032			; vypis chybu, ak parameter nebol hex
5628   91D9 2A 72 C0		LD HL,(0C072H)			; pozicia v bufri
5629   91DC 7E			LD A,(HL)			; nacitaj znak
5630   91DD FE 2F		CP 2FH				; je to '/' ?
5631   91DF C2 EB 91		JP NZ,L0322			; este nie
5632   91E2 CD E5 90		CALL L0301			; skontroluj, ci sa jedna o typ (G, D, T alebo M), podla toho nastav zahlavie
5633   91E5 C2 6C 92		JP NZ,L0295			; neznamy typ, hlasenie 'LAN off'
5634   91E8 C3 FA 91		JP L0321			; aj typ 'T' by mal byt potlaceny, lebo je nezmyslom, avsak nie je
; docitaj cielovu adresu
5635   91EB CD 92 95	L0322:	CALL L0297			; dalsi znak v bufri
5636   91EE CD 7E 91		CALL L0302			; nacitaj cielovu adresu
5637   91F1 C2 49 80		JP NZ,L0032			; 'Error in address'
5638   91F4 CD C5 90		CALL L0303			; uz musi nasledovat '/', a 'G' 'M' alebo 'D'
5639   91F7 C2 49 80		JP NZ,L0032			; inak 'No command'
; prikaz bol v poriadku dekodovany, idu sa vyziadat data
5640   91FA CD AC 90	L0321:	CALL L0305			; odoslanie zahlavia dat
5641   91FD CD 3A 95		CALL L0306			; kontrola chybovych kodov
5642   9200 3A BF C1		LD A,(0C1BFH)			; skontroluj LAN status
5643   9203 A7			AND A				; ak je tam chybovy kod, vypis hlasenie
5644   9204 C2 49 80		JP NZ,L0032
5645   9207 CD A3 88		CALL L0037			; pipnutie
5646   920A CD 7E 92		CALL L0323			; cakaj na prijem zahlavia z druheho pocitaca
5647   920D CD 3A 95		CALL L0306			; kontrola chybovych kodov
5648   9210 3A BF C1		LD A,(0C1BFH)			; skontroluj LAN status
5649   9213 A7			AND A
5650   9214 C2 49 80		JP NZ,L0032			; pri chybe vypis hlasenie
5651   9217 CD B8 92		CALL L0324			; data prisli, podla typu dat ich uloz do RAM
5652   921A CD 3A 95		CALL L0306			; kontrola chybovych kodov
5653   921D C3 49 80		JP L0032			; vypis hlasenie
; --------------------------------------------------------------------------------------------------------
; sem je presunuta povodna rutina cakania medzi kontrolami klavesnice (volane z INKLAV)
; povodne na 8C1B (i ked tam zostal povodny kod), volana z adresy 84AC
; pocas cakania sa teraz bude testovat, ci neprichadzaju nejake data
5654   9220 C5		L9220:	PUSH BC
5655   9221 47			LD B,A				; urob BC prazdnych cyklov
5656   9222 0B		L0325:	DEC BC
5657   9223 79			LD A,C
5658   9224 B0			OR B
5659   9225 C2 22 92		JP NZ,L0325
5660   9228 C1			POP BC
; tu sa koncila povodna rutina a nasledovala len instrukcia RET
; teraz sa skontroluje, ci je siet aktivovana
5661   9229 3A 7D C0		LD A,(0C07DH)			; nacitaj premennu LANFLG (moze byt 00 alebo FF)
5662   922C A7			AND A
5663   922D C8			RET Z				; LAN neaktivovana, rutina konci
; ak je LAN aktivovana, bude sa zistovat, ci je na linke nejaka komunikacia
5664   922E DB F6		IN A,(0F6H)			; nacitaj mgf-in
5665   9230 17			RLA				; do CY
5666   9231 D0			RET NC				; ziadny prenos na linke, rutina konci
; na linke je poziadavka na prenos, treba riadit komunikaciu
; na zasobniku vsak zostali ulozene BC, HL a navratova adresa
5667   9232 E1			POP HL				; zrusena navratova adresa z rutiny INKLAV
5668   9233 21 00 00		LD HL,0000H			; do HL nacitaj SP
5669   9236 39			ADD HL,SP
5670   9237 22 BC C1		LD (0C1BCH),HL			; zasobnik sa ulozi do novej premennej LANSP
5671   923A 31 00 7F		LD SP,7F00H			; docasny zasobnik
5672   923D CD 75 92		CALL L0326			; prijem zahlavia dat
5673   9240 CD 3A 95		CALL L0306			; kontrola chybovych kodov
5674   9243 3A BF C1		LD A,(0C1BFH)			; nacitaj status LAN
5675   9246 A7			AND A
5676   9247 CA 50 92		JP Z,L0327			; musi byt 00 (OK)
5677   924A CD 9F 93		CALL L0328			; male zdrzanie
5678   924D C3 60 92		JP L0329			; pokracuj nizsie
5679   9250 CD 9B 92	L0327:	CALL L0330			; prisla hlavicka, teraz sa treba podle nej rozhodnut, ci sa data budu odosielat alebo prijmat
5680   9253 CD 3A 95		CALL L0306			; kontrola chybovych kodov
5681   9256 3A BF C1		LD A,(0C1BFH)			; nacitaj status LAN
5682   9259 A7			AND A
5683   925A CA 60 92		JP Z,L0329
5684   925D CD 9F 93		CALL L0328			; male zdrzanie
5685   9260 CD 89 8A	L0329:	CALL L0308			; pipni a vypis hlasenie
5686   9263 2A BC C1		LD HL,(0C1BCH)			; obnov hodnotu SP
5687   9266 F9			LD SP,HL
5688   9267 E1			POP HL				; obnovia sa registre HL a BC
5689   9268 C1			POP BC				; ktore ulozila na zasobnik rutina INKLAV
5690   9269 C3 A1 84		JP L0010			; vola sa rutina INKLAV a cita sa klavesnica odznova
; vypis chyboveho hlasenia 'No command'
5691   926C 21 92 83	L0295:	LD HL,8392H			; 'No command'
; vypis chyboveho hlasenia podla HL
5692   926F 22 74 C0	L0398:	LD (0C074H),HL			; zapis adresu chybovej spravy
5693   9272 C3 49 80		JP L0032			; vypis chyboveho hlasenia
; prijem zahlavia dat
5694   9275 21 88 94	L0326:	LD HL,9488H			; oznam 'LAN ACTIVED, WAIT PLEASE'
5695   9278 22 74 C0		LD (0C074H),HL			; do systemovej premennej MESAGE
5696   927B CD 89 8A		CALL L0308 			; pipni a vypis hlasenie
5697   927E AF		L0323:	XOR A				; nastav status na OK
5698   927F 32 BF C1		LD (0C1BFH),A
5699   9282 21 B0 C1		LD HL,0C1B0H			; bude sa prijmat hlavicka 10 bajtov a ukladat
5700   9285 11 0A 00		LD DE,000AH			; do systemovych premennych
5701   9288 CD C3 94		CALL L0331			; prijem bloku dat
5702   928B 3A BF C1		LD A,(0C1BFH)			; skontroluj status
5703   928E A7			AND A				; ak je 00, data boli prijate
5704   928F C0			RET NZ
5705   9290 CD D8 94		CALL L0332			; nacitaj este kontrolny sucet
5706   9293 B8			CP B				; a porovnaj s vypocitanym suctom
5707   9294 C8			RET Z				; ak sedia, tak super
5708   9295 3E 34		LD A,34H			; inak hlasenie 'CHECK SUM ERROR'
5709   9297 32 BF C1		LD (0C1BFH),A
5710   929A C9			RET
; boli vyziadane data z druhej strany
5711   929B 3A B2 C1	L0330:	LD A,(0C1B2H)			; premenna NUMFIL oznacuje smer prenosu
5712   929E FE 52		CP 52H				; posiela data vysielac?
5713   92A0 CA B8 92		JP Z,L0324			; ak ano, data musim ulozit
5714   92A3 3A B0 C1		LD A,(0C1B0H)			; zamen LAN ID identifikatory vysielaca/prijmaca
5715   92A6 32 B1 C1		LD (0C1B1H),A
5716   92A9 3A BE C1		LD A,(0C1BEH)
5717   92AC 32 B0 C1		LD (0C1B0H),A
5718   92AF 28 50		JR Z,L0333			; WTF ????  Huston, mame problem! ************************************
								; spravne by tu asi malo byt LD A, 54h
5719   92B1 32 B2 C1		LD (0C1B2H),A
5720   92B4 CD 82 90		CALL L0304			; odosli zahlavie dat a blok dat
5721   92B7 C9			RET
; podla typu dat sa budu ukladat do RAM na definovane miesta
5722   92B8 3A B3 C1	L0324:	LD A,(0C1B3H)			; typ datoveho bloku
5723   92BB FE 54		CP 54H				; 'T' - text?
5724   92BD CA C8 92		JP Z,L0334
5725   92C0 FE 47		CP 47H				; 'G' - VideoRAM?
5726   92C2 CA F7 92		JP Z,L0335
5727   92C5 C3 4E 93		JP L0336			; ostatne typy blokov
; prijme sa textovy blok dat a rovno sa bude vypisovat na obrazovke
5728   92C8 3E 0D	L0334:	LD A,0DH			; vloz novy riadok
5729   92CA CD 00 85		CALL L0030			; PRTOUT - vypis znaku na obrazovke
5730   92CD 2A B6 C1		LD HL,(0C1B6H)			; dlzka dat
5731   92D0 06 00		LD B,00H                        ; bude sa vytvarat kontrolny sucet
5732   92D2 CD D8 94	L0337:	CALL L0332			; prijmi jeden bajt
5733   92D5 5F			LD E,A				; uschovaj
5734   92D6 80			ADD A,B				; pripocitaj ku kontrolnemu suctu
5735   92D7 47			LD B,A
5736   92D8 3A BF C1		LD A,(0C1BFH)			; prenos uspesny?
5737   92DB A7			AND A
5738   92DC C0			RET NZ				; ak nie, skonci
5739   92DD 7B			LD A,E				; obnov nacitany znak
5740   92DE CD 00 85		CALL L0030			; PRTOUT - vypis znaku na obrazovke
5741   92E1 2B			DEC HL				; pocitadlo
5742   92E2 7D			LD A,L
5743   92E3 B4			OR H
5744   92E4 C2 D2 92		JP NZ,L0337			; opakuj, kym pridu vsetky znaky
5745   92E7 3E 0D		LD A,0DH                        ; vloz novy riadok
5746   92E9 CD 00 85		CALL L0030			; PRTOUT - vypis znaku na obrazovke
5747   92EC CD D8 94		CALL L0332			; prijmi kontrolny sucet
5748   92EF B8			CP B				; porovnaj s vypocitanym
5749   92F0 C8			RET Z				; ak sedi, OK
5750   92F1 3E 34		LD A,34H			; inak chyba 'Check sum error'
5751   92F3 32 BF C1		LD (0C1BFH),A
5752   92F6 C9			RET
; budu sa prijmat graficke data z VideoRAM
; i ked je jasne, kam data patria, aj tak sa tieto udaje beru zo zahlavia
5753   92F7 CD A7 85	L0335:	CALL L859F			; vymaz obrazovky
5754   92FA 2A B6 C1		LD HL,(0C1B6H)			; dlzka dat do DE (vzdy 3D00)
5755   92FD EB			EX DE,HL
5756   92FE 2A B8 C1		LD HL,(0C1B8H)			; tu sa zacnu zapisovat data (vzdy je C000)
5757   9301 06 00	L0333:	LD B,00H			; bude sa tvorit kontrolny sucet
5758   9303 0E 30	L0343:	LD C,30H
5759   9305 E5			PUSH HL
5760   9306 CD D8 94	L0340:	CALL L0332			; nacitaj bajt z linky
5761   9309 77			LD (HL),A			; vykresli na obrazovke
5762   930A 80			ADD A,B				; uprav kontrolny sucet
5763   930B 47			LD B,A
5764   930C 3A BF C1		LD A,(0C1BFH)			; skontroluj, ci bol prenos OK
5765   930F A7			AND A
5766   9310 CA 15 93		JP Z,L0338
5767   9313 E1		L0341:	POP HL				; prenos neuspesny, daj do poriadku zasobnik
5768   9314 C9			RET
5769   9315 23		L0338:	INC HL				; na dalsi bajt
5770   9316 1B			DEC DE				; zniz pocitadlo bajtov
5771   9317 7B			LD A,E
5772   9318 B2			OR D
5773   9319 CA 42 93		JP Z,L0339			; vsetky data prenesene
5774   931C 0D			DEC C				; pocitaj bajty na mikroriadok
5775   931D C2 06 93		JP NZ,L0340			; musi byt 48 bajtov
5776   9320 0E 10		LD C,10H			; ostava 16 bajtov
5777   9322 CD D8 94	L0342:	CALL L0332			; dalsich 16 bajtov sa nacita
5778   9325 80			ADD A,B				; bude sa z nich vytvarat kontrolny sucet
5779   9326 47			LD B,A				; ale inak sa len zahodia, aby nezmenili systemove premenne
5780   9327 3A BF C1		LD A,(0C1BFH)			; prenos bajtu v poriadku?
5781   932A A7			AND A
5782   932B C2 13 93		JP NZ,L0341
5783   932E 1B			DEC DE				; zniz pocitadlo bajtov
5784   932F 7B			LD A,E
5785   9330 B2			OR D
5786   9331 CA 42 93		JP Z,L0339
5787   9334 0D			DEC C				; cakaj na 16 bajtov
5788   9335 C2 22 93		JP NZ,L0342
5789   9338 E1			POP HL				; obnov pociatocnu adresu mikroriadku
5790   9339 D5			PUSH DE
5791   933A 11 40 00		LD DE,0040H			; zvys o 64, cim bude ukazovat na dalsi mikroriadok
5792   933D 19			ADD HL,DE			; co bolo uplne zbytocne, lebo stacilo navysovat HL
5793   933E D1			POP DE				; pocas prijmu poslednych 16 bajtov
5794   933F C3 03 93		JP L0343			; nacitaj data dalsieho mikroriadku
5795   9342 E1		L0339:	POP HL				; vsetky bajty prijate
5796   9343 CD D8 94		CALL L0332			; este kontrolny sucet
5797   9346 B8			CP B				; porovnaj s vypocitanym
5798   9347 C8			RET Z				; super, je to OK
5799   9348 3E 34		LD A,34H			; chyba 'Check sum error'
5800   934A 32 BF C1		LD (0C1BFH),A
5801   934D C9			RET
; nacita sa datovy blok iny ako G a T
5802   934E 2A B6 C1	L0336:	LD HL,(0C1B6H)			; dlzka bloku
5803   9351 EB			EX DE,HL
5804   9352 2A B8 C1		LD HL,(0C1B8H)			; cielova adresa
5805   9355 CD C3 94		CALL L0331			; nacitaj blok dat
5806   9358 3A BF C1		LD A,(0C1BFH)			; kontrola prenosu
5807   935B A7			AND A
5808   935C C0			RET NZ				; chyba pri prenose
5809   935D CD D8 94		CALL L0332			; nacitaj kontrolny sucet
5810   9360 B8			CP B				; porovnaj s vypocitanym
5811   9361 CA 6A 93		JP Z,L0344
5812   9364 3E 34		LD A,34H			; inak hlasenie 'CHECK SUM ERROR'
5813   9366 32 BF C1		LD (0C1BFH),A
5814   9369 C9			RET
; teraz sa skontroluje, ci sa jedna o Basic program alebo o strojovy kod
5815   936A 3A B3 C1	L0344:	LD A,(0C1B3H)			; typ dat
5816   936D FE 4D		CP 4DH				; M - code
5817   936F C2 79 93		JP NZ,L0345
5818   9372 31 00 80		LD SP,8000H			; nastav zasobnik
5819   9375 2A B8 C1		LD HL,(0C1B8H)			; a spusti kod
5820   9378 E9			JP (HL)
5821   9379 FE 42	L0345:	CP 42H				; B - Basic program
5822   937B C0			RET NZ
5823   937C 21 A9 94		LD HL,94A9H			; nastav spravu
5824   937F 22 74 C0		LD (0C074H),HL			; 'RUN BASIC PROGRAM'
5825   9382 CD 89 8A		CALL L0308			; pipni a vypis hlasenie
5826   9385 21 00 98		LD HL,9800H			; nacita Basic interpreter z EPROM
5827   9388 11 00 00		LD DE,0000H
5828   938B CD 12 90		CALL L0289
5829   938E 2A B6 C1		LD HL,(0C1B6H)			; dlzka dat
5830   9391 EB			EX DE,HL
5831   9392 2A B8 C1		LD HL,(0C1B8H)			; cielova adresa
5832   9395 19			ADD HL,DE
5833   9396 22 7A 5E		LD (5E7AH),HL			; oznac koniec programu v Basic-u
5834   9399 CD 9F 93		CALL L0328			; cakaj chvilu
5835   939C C3 00 00		JP 0000H			; start Basicu
; tento kus kodu je velkou zahadou, lebo skok ide do dat, umiestnenych nad generatorom znakov v ROM
; 01Dh,0C2h,0B5h, ktory je ciastocne aj znakom '`' (60h)
; co je by mala byt cakacia slucka
5836   939F 11 00 80	L0328:	LD DE,8000H
5837   93A2 C3 B5 88		JP L0160
; data su nachystane, v HL je pociatocna adresa, v DE je dlzka
; teraz sa vyvola posjenie a odoslu data
5838   93A5 06 00	L0307:	LD B,00H
5839   93A7 7E		L0347:	LD A,(HL)			; nacitaj bajt
5840   93A8 80			ADD A,B				; kontrolny sucet
5841   93A9 47			LD B,A
5842   93AA 4E			LD C,(HL)			; bajt do C
5843   93AB CD BF 93		CALL L0346			; nadviaz spojenie, ak je neuspesne tak flag=32h
5844   93AE 3A BF C1		LD A,(0C1BFH)			; nacitaj status LAN
5845   93B1 A7			AND A				; ak je nula, spojenie sa podarilo a bajt je odoslany
5846   93B2 C0			RET NZ				; nespojene
5847   93B3 23			INC HL				; priprav sa na dalsi bajt
5848   93B4 1B			DEC DE				; zniz pocitadlo
5849   93B5 7A			LD A,D				; vsetky data odoslane?
5850   93B6 B3			OR E
5851   93B7 C2 A7 93		JP NZ,L0347			; posli dalsi bajt
5852   93BA 48			LD C,B				; data odoslane, este sa odosle kontrolny sucet
5853   93BB CD BF 93		CALL L0346
5854   93BE C9			RET
; teraz sa Mato pokusi spojit s koncentratorom alebo s inym Matom
5855   93BF AF		L0346:	XOR A				; nastav status siete na 00
5856   93C0 32 BF C1		LD (0C1BFH),A			; LANSTA
5857   93C3 D5			PUSH DE
5858   93C4 C5			PUSH BC
5859   93C5 3E 01		LD A,01H			; nastav bit pre mgf-out
5860   93C7 D3 F6		OUT (0F6H),A			; zapis na port
5861   93C9 11 00 90		LD DE,9000H			; casova konstanta
5862   93CC DB F6	L0349:	IN A,(0F6H)			; nacitaj stav portu
5863   93CE 17			RLA				; bit 7 je mgf-in
5864   93CF DA E0 93		JP C,L0348			; linka hore? druha strana je pripravena
5865   93D2 1B			DEC DE				; kontroluj cas
5866   93D3 7A			LD A,D
5867   93D4 B3			OR E
5868   93D5 C2 CC 93		JP NZ,L0349			; stale zistuj, ci druha strana je pripravena
5869   93D8 3E 32		LD A,32H			; cas vyprsal, nastav flag (NO READY FOR DATA)
5870   93DA 32 BF C1		LD (0C1BFH),A
5871   93DD C3 18 94		JP L0350
; teraz sa odosle start-bit, 8 bitov a stop-bit
5872   93E0 AF		L0348:	XOR A				; nuluj bit pre mgf-out (start bit)
5873   93E1 D3 F6		OUT (0F6H),A			; zapis na port
5874   93E3 CD 6F 95		CALL L0351			; casovanie
5875   93E6 06 08		LD B,08H			; bude sa vysielat 8 bitov
5876   93E8 79		L0353:	LD A,C				; z C sa budu vysielat jednotlive bity
5877   93E9 E6 01		AND 01H				; LSB na port
5878   93EB D3 F6		OUT (0F6H),A			; zapis
5879   93ED 79			LD A,C
5880   93EE 1F			RRA				; nachystaj dalsi bit
5881   93EF 4F			LD C,A
5882   93F0 CD 75 95		CALL L0352			; casovanie jednotlivych bitov
5883   93F3 05			DEC B				; zniz pocitadlo bitov
5884   93F4 C2 E8 93		JP NZ,L0353			; opakuj 8-krat
5885   93F7 3E 01		LD A,01H			; nastav bit mgf-out (stop bit)
5886   93F9 D3 F6		OUT (0F6H),A			; zapis na port
5887   93FB CD 75 95		CALL L0352			; casovanie, stop-bit ma dvojnasobnu dlzku
5888   93FE CD 75 95		CALL L0352			; casovanie
5889   9401 AF			XOR A				; nuluj mgf-out
5890   9402 D3 F6		OUT (0F6H),A			; zapis na port
5891   9404 11 00 90		LD DE,9000H			; teraz sa bude cakat na odpoved
5892   9407 DB F6	L0354:	IN A,(0F6H)			; nacitaj mgf-in
5893   9409 17			RLA				; mgf-in do CY
5894   940A D2 18 94		JP NC,L0350			; ak je linka dole, tak druha strana potvrdila bit
5895   940D 1B			DEC DE				; ak nie, bude sa chvilu cakat
5896   940E 7A			LD A,D				; zniz pocitadlo
5897   940F B3			OR E
5898   9410 C2 07 94		JP NZ,L0354			; cakaj na odpoved
5899   9413 3E 31		LD A,31H			; nastav status (FRAME ERROR)
5900   9415 32 BF C1		LD (0C1BFH),A
5901   9418 AF		L0350:	XOR A				; nuluj bit mgf-out
5902   9419 D3 F6		OUT (0F6H),A			; zapis na port
5903   941B C1			POP BC				; obnov kontrolny sucet
5904   941C D1			POP DE				; a dlzku dat
5905   941D C9			RET
; oznamy
5906   941E 2B			DB	'++ TRANSFER OK ++'
				DB	0Dh
				DB	'++ FRAME ERROR ++'
				DB	0Dh
				DB	'++ NO READY FOR DATA ++'
				DB	0Dh
				DB	'++ NO READY FOR SEND ++'
				DB	0Dh
				DB	'++ CHECK SUM ERROR ++'
				DB	0Dh
				DB	'++ LAN ACTIVED - WAIT PLEASE! ++'
				DB	0Dh
				DB	'++ RUN BASIC PROGRAM ! ++'
				DB	0Dh
; prijem bloku dat s dlzkou DE a ulozenie dat od adresy HL
6039   94C3 06 00	L0331:	LD 	B,00H			; kontrolny sucet je na zaciatku nula
6040   94C5 CD D8 94	L0371:	CALL 	L0332			; nacitaj jeden bajt
6041   94C8 77			LD 	(HL),A			; uloz ho na urcene miesto
6042   94C9 80			ADD 	A,B			; vytvaraj kontrolny sucet
6043   94CA 47			LD 	B,A
6044   94CB 3A BF C1		LD 	A,(0C1BFH)		; skontroluj status
6045   94CE A7			AND 	A			; ak bol bajt prijaty v poriadku, je status 00
6046   94CF C0		L0370:	RET 	NZ			; inak skonci
6047   94D0 23			INC 	HL			; miesto pre dalsi bajt
6048   94D1 1B		L0373:	DEC 	DE			; zniz pocitadlo dat
6049   94D2 7A			LD 	A,D
6050   94D3 B3			OR 	E
6051   94D4 C2 C5 94		JP 	NZ,L0371		; citaj, kym bude pocitadlo 0000
6052   94D7 C9			RET				; vsetky data nacitane
; zisti, ci je linka pripravena na prijem a prijmi jeden bajt
6053   94D8 AF		L0332:	XOR 	A			; nastav status na OK
6054   94D9 32 BF C1		LD 	(0C1BFH),A
6055   94DC D5			PUSH 	DE
6056   94DD C5			PUSH 	BC
6057   94DE 11 00 90		LD DE,9000H			; bude sa merat cas, kym pride ACK
6058   94E1 DB F6		IN A,(0F6H)			; citaj mgf-in
6059   94E3 17			RLA				; MSB do CY
6060   94E4 DA F5 94		JP C,L0381			; prislo ACK, pokracuje sa v komunikacii
6061   94E7 1B			DEC DE				; zniz pocitadlo timeoutu
6062   94E8 7A			LD A,D                          ; vyprsal cas?
6063   94E9 B3			OR E
6064   94EA C2 E1 94		JP NZ,L0382			; nie, cakaj dalej na ACK
6065   94ED 3E 33		LD A,33H			; zmen status na 'NO READY FOR SEND'
6066   94EF 32 BF C1	L0375:	LD (0C1BFH),A			; LANSTA
6067   94F2 C3 33 95		JP L0383
; teraz sa odosle po sieti log H, a caka sa na prijem log L
6068   94F5 3E 01	L0381:	LD A,01H			; mgf-out na H
6069   94F7 D3 F6		OUT (0F6H),A			; zapis na port
6070   94F9 11 00 90		LD DE,9000H			; bude sa merat cas
6071   94FC DB F6	L0385:	IN A,(0F6H)			; citaj mgf-in
6072   94FE 17			RLA				; MSB do CY
6073   94FF D2 0B 95	L0376:	JP NC,L0384			; prislo ACK, idu sa citat bity
6074   9502 1B			DEC DE				; zniz pocitadlo timeoutu
6075   9503 7A			LD A,D				; vyprsal cas?
6076   9504 B3			OR E
6077   9505 C2 FC 94		JP NZ,L0385			; ak nie, cakaj na ACK
6078   9508 C3 2E 95		JP L0386			; co je vela to je malo, cas vyprsal
; komunikacia pripravena, bude sa nacitavat jeden bajt
6079   950B 0E 08	L0384:	LD C,08H			; 8 bitov
6080   950D 06 00		LD B,00H			; v B sa bude budovat preneseny bajt
6081   950F CD 7C 95	L0388:	CALL L0387			; casovanie prijmu dat
6082   9512 DB F6		IN A,(0F6H)			; citaj mgf-in
6083   9514 17			RLA				; MSB do CY
6084   9515 78			LD A,B				; pridaj novy bit do B
6085   9516 1F			RRA
6086   9517 47			LD B,A
6087   9518 0D			DEC C				; zniz pocitadlo  bitov
6088   9519 C2 0F 95		JP NZ,L0388			; bude sa opakovat 8-krat
6089   951C CD 7C 95		CALL L0387			; casovanie prijmu dat
6090   951F 11 00 90		LD DE,9000H
; v tejto chvili by mal prichadzat stop-bit, ale nie je nijako kontrolovany
; i ked sa to v prirucke uvadza
; teraz sa caka, ze vysielac bude signalizovat koniec prenosu log L, na co prijmac odpovie tiez log L
6091   9522 DB F6	L0389:	IN A,(0F6H)			; mgf-in
6092   9524 17			RLA				; MSB do CY
6093   9525 D2 33 95		JP NC,L0383			; vysielac poslal na linku log L (koniec prenosu)
6094   9528 1B			DEC DE				; bude sa chvilu cakat na vysielac
6095   9529 7A			LD A,D
6096   952A B3			OR E
6097   952B C2 22 95		JP NZ,L0389
6098   952E 3E 31	L0386:	LD A,31H			; nastav status'FRAME ERROR'
6099   9530 32 BF C1		LD (0C1BFH),A
6100   9533 AF		L0383:	XOR A				; mgf-out na L
6101   9534 D3 F6		OUT (0F6H),A			; nastav port
6102   9536 78			LD A,B				; nacitany bajt (ak bolo uspesne citanie) do A
6103   9537 C1			POP BC				; uprac a skonci
6104   9538 D1			POP DE
6105   9539 C9			RET
; kontrola chybovych kodov
6106   953A 3A BF C1	L0306:	LD A,(0C1BFH)			; nacitaj LAN status
6107   953D A7			AND A				; podla statusu sa vypise hlasenie na obrazovke
6108   953E CA 57 95		JP Z,L0390			; 'TRANSFER OK'
6109   9541 FE 31		CP 31H
6110   9543 CA 5D 95		JP Z,L0391			; 'FRAME ERROR'
6111   9546 FE 32		CP 32H
6112   9548 CA 63 95		JP Z,L0392			; 'NO READY FOR DATA'
6113   954B FE 33		CP 33H
6114   954D CA 69 95		JP Z,L0393			; 'NO READY FOR SEND'
6115   9550 21 72 94		LD HL,9472H
6116   9553 22 74 C0	L0394:	LD (0C074H),HL			; nastav do premennej MESAGE
6117   9556 C9			RET
6118   9557 21 1E 94	L0390:	LD HL,941EH			; 'TRANSFER OK'
6119   955A C3 53 95		JP L0394
6120   955D 21 30 94	L0391:	LD HL,9430H			; 'FRAME ERROR'
6121   9560 C3 53 95		JP L0394
6122   9563 21 42 94	L0392:	LD HL,9442H			; 'NO READY FOR DATA'
6123   9566 C3 53 95		JP L0394
6124   9569 21 5A 94	L0393:	LD HL,945AH			; 'NO READY FOR SEND'
6125   956C C3 53 95		JP L0394
; casovanie
6126   956F 3A FE C1	L0351:	LD A,(0C1FEH) 			; hodnota 10h
6127   9572 C3 7F 95		JP L0395
; casovanie (dvojnasobny cas)
6128   9575 3A FE C1	L0352:	LD A,(0C1FEH)			; hodnota 10h
6129   9578 17			RLA				; * 2
6130   9579 C3 7F 95		JP L0395
; casovanie, ale nikde sa nevyuziva
6131   957C 3A FF C1	L0387:	LD A,(0C1FFH)			; hodnota 21h
; spolocna rutina pre vsetky casovace
6132   957F 3D		L0395:	DEC A				; znizuj hodnotu casovaca
6133   9580 C2 7F 95		JP NZ,L0395
6134   9583 C9			RET
; kontroluje buffer, preskakuje medzery
6135   9584 2A 72 C0	L0291:	LD HL,(0C072H)			; nacitaj poziciu v buffri
6136   9587 7E			LD A,(HL)			; nacitaj znak
6137   9588 FE 20		CP 20H				; je to medzera?
6138   958A 22 72 C0		LD (0C072H),HL			; uloz poslednu poziciu
6139   958D C0			RET NZ				; ak nie, koniec
6140   958E 23			INC HL				; dalsi znak
6141   958F C3 84 95		JP L0291
; posunie sa v buffri ale inak nerobi nic
6142   9592 2A 72 C0	L0297:	LD HL,(0C072H)			; pozicia
6143   9595 23			INC HL				; posun na dalsi bajt
6144   9596 22 72 C0		LD (0C072H),HL			; uloz
6145   9599 C9			RET
; kontroluje flag LAN, ci bolo vysielanie povolene prikazom SET
; ak nie, nastavi hlasenie 'LAN = OFF'
6146   959A 3A 7D C0	L0290:	LD A,(0C07DH)			; nacitaj flag
6147   959D A7			AND A				; ak je nenulovy (teda FF)
6148   959E C0			RET NZ
6149   959F 21 D6 95		LD HL,95D6H			; nastav hlasenie 'LAN = OFF'
6150   95A2 22 74 C0		LD (0C074H),HL			; uloz do premennej MESAGE
6151   95A5 C9			RET
			;******************************************************************************
			;obsluha prikazu MONITORu SET
			;******************************************************************************
6152   95A6 CD 84 95		CALL L0291			; preskoc kazdu medzeru v bufri
6153   95A9 FE 2F		CP 2FH				; prvy znak je '/' ?
6154   95AB CA E4 95		JP Z,L0396			; zobraz napovedu
6155   95AE CD 60 91		CALL L0292			; nacitaj parameter
6156   95B1 DA C2 95		JP C,L0397			; ale musi byt hex
6157   95B4 32 BE C1		LD (0C1BEH),A			; uloz ako novu premennu NETID
6158   95B7 3E FF	L0406:	LD A,0FFH			; flag: sietova komunikacia
6159   95B9 21 C9 95		LD HL,95C9H			; HL na spravu 'LAN = ON'
6160   95BC 32 7D C0	L0399:	LD (0C07DH),A			; nastav flag
6161   95BF C3 6F 92		JP L0398			; vypis spravu na obrazovku, cim prikaz konci
6162   95C2 21 D6 95	L0397:	LD HL,95D6H 			; pri hocijakom inom parametri
6163   95C5 AF			XOR A				; sa nastavi flag: odpojena siet
6164   95C6 C3 BC 95		JP L0399			; flag sa ulozi a vypise sa 'LAN = OFF'
; texty hlaseni
6165   95C9 2B			DB	'++ LAN=ON ++'
				DB	0Dh
6176   95D6			DB	'++ LAN=OFF ++'
; vypis napovedy na obrazovku
6188   95E4 CD A7 85	L0396:	CALL L859F			; vymaz obrazovky
6189   95E7 21 00 96		LD HL,9600H			; adresa textov napovedy
6190   95EA 7E		L0405:	LD A,(HL)			; nacitaj znak po znaku
6191   95EB A7			AND A				; je koniec textu?
6192   95EC CA F6 95		JP Z,L0404
6193   95EF CD 00 85		CALL L0030			; tlac cez PRTOUT
6194   95F2 23			INC HL				; dalsi znak
6195   95F3 C3 EA 95		JP L0405			; opakuj kym je co tlacit

6196   95F6 3A 7D C0	L0404:	LD A,(0C07DH)
6197   95F9 A7			AND A
6198   95FA CA C2 95		JP Z,L0397
6199   95FD C3 B7 95		JP L0406
				DB	'*****************  LAN HELP   ****************'
				DB	0Dh, 0Dh, 0Dh
				DB	'SET AD 	     AD=2xHEX AKTIVUJE LAN stn.'
				DB	0Dh
				DB	'		     AD=xx DEAKTIVUJE LAN stn.'
				DB	0Dh
				DB	'SET/		     HELP
				DB	0Dh, 0Dh
				DB	'VYSLANIE BLOKU ADRESATOVI (AD):'
				DB	0Dh, 0Dh
				DB	'SEND AD/X...text    X = G,B,T'
				DB	0Dh
				DB	'SEND AD;OD-DO/X     X = G,T,D,M'
				DB	0Dh
				DB	'SEND AD;OD-DO;TO/X  X = G,M,D'
				DB	0Dh, 0Dh, 0Dh
				DB	'VYZIADANIE BLOKU OD ADRESATA (AD):'
				DB	0Dh, 0Dh
				DB	'READ AD/X	     X = G,B'
				DB	0Dh
; pre prikaz READ nema typ 'T' vyznam, naopak, chyba tam typ 'M'
				DB	'READ AD;OD-DO/X     X = G,D,T'
				DB	0Dh
				DB	'READ AD;OD-DO;TO/X  X = G,M,D'
				DB	0Dh, 0Dh
				DB	'T = TEXT'
				DB	0Dh
				DB	'B = BASIC PROGRAM'
				DB	0Dh
				DB	'G = GRAFIKA'
				DB	0Dh
				DB	'M = PROGRAM V STROJ. KODE'
				DB	0Dh
				DB	'D = DATA'
				DB	00h, 00h
6573   97F0 FF			DB	0FFh, 0FFh, 0FFh, 0FFh
6577   97F4 FF		L0483:	DB	0FFh, 0FFh, 0FFh, 0FFh
6581   97F8 FF			DB	0FFh, 0FFh, 0FFh, 0FFh
6585   97FC FF			DB	0FFh
6586   97FD FF		L0481:	DB	0FFh
6587   97FE BB	FF		DB	0BBh, 0FFh

; nasleduje Demo a Basic
